﻿function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
};
$(document).ready(function () {
    var DataTable = $.fn.dataTable;
    $.extend(true, DataTable.Buttons.defaults, {
        dom: {
            button: {
                className: 'btn btn-primary btn-sm'
            }
        }
    });

    var $datatablesResponsive1 = $('#galaxkey_table4');
    if ($datatablesResponsive1 != undefined) {
        $table = $datatablesResponsive1.DataTable({
            columnDefs: [{
                orderable: false,
                className: 'select-checkbox',
                targets: 0
            }],
            select: true,
            order: [[1, 'asc']],
            buttons: ['print', 'copy', 'pdf', 'excel',
                {
                    text: 'Send Secure Email',
                    action: function () {
                        var count = $('#galaxkey_table4 tr.selected').length;
                        if (count > 0) {
                            var $arrSelectedEmails = $('#galaxkey_table4 tr.selected td[data-type=email]');
                            var $emails = "";
                            for (i = 0; i < $arrSelectedEmails.length; i++) {
                                $emails = $emails + $arrSelectedEmails[i].innerText + ",";
                            }
                            var filePath = "/SecureEmails/ContactsSendEmail";
                            $('<form></form>')
                                .attr('method', 'POST')
                                .attr('action', filePath)
                                .append('<input type=\'text\' name=\'emails\' id=\'emails\' value=\'' + b64EncodeUnicode($emails) + '\'>')
                                .appendTo('body').submit().remove();
                        }
                        else {
                            toastr.error('Please select email addresses', { "positionClass": "toast-top-center" });
                        }
                    }
                }],
            responsive: true,
            dom: "<'row'<'col-sm-6 col-sm-push-6'i><'col-sm-6 col-md-pull-6'f>>" + "<'row'<'col-sm-12'tr>>" + "<'row'<'col-sm-6'l><'col-sm-6'p>>",
            language: {
                paginate: {
                    previous: '&laquo;',
                    next: '&raquo;'
                },
                search: "_INPUT_",
                searchPlaceholder: "Search…"
            },
        }).buttons().container().appendTo('#galaxkey_table4_wrapper .col-sm-6:eq(1)');

    }


    $(document).on('change', '#selectall', function (e) {
        if ($('#selectall').prop("checked") == true) {
            $onetime = true;
            $("#galaxkey_table4 tr[role=row]").each(function () {
                if ($onetime == false) {
                    $this = $(this);
                    $this.addClass('selected');
                }
                else {
                    $onetime = false;
                }
            });

        }
        else if ($('#selectall').prop("checked") == false) {
            $('#galaxkey_table4 tr').removeClass('selected');
        }
    });
});