﻿function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
}
function b64DecodeUnicode(str) {
    // Going backwards: from bytestream, to percent-encoding, to original string.
    return decodeURIComponent(atob(str).split('').map(function (c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));
}

// This function gets the standard Galaxkey Secured Email Templates
function fnGetTemplates() {
    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: '/CorporateConfiguration/StandardTemplates',
        data: '',
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = jSon['result'];
                if (bResult == false) {
                    $("#dialogMessage").text(jSon['message']);
                    $("#dialog-message").dialog('open');
                }
                else {
                    var strStdHtml = jSon['html'];
                    var strStdText = jSon['text'];
                    CKEDITOR.instances.custom_encryption_email_html.setData(strStdHtml);
                    $('#custom_encryption_email_text').val(strStdText);
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
}

// This function gets the standard Galaxkey geo fencing template
function fnGetTemplatesForGeoFencing() {
    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: '/CorporateConfiguration/StandardTemplates',
        data: '',
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = jSon['result'];
                if (bResult == false) {
                    $("#dialogMessage").text(jSon['message']);
                    $("#dialog-message").dialog('open');
                }
                else {
                    var strgeofencing_html_template = jSon['geofencing_html_template'];
                    CKEDITOR.instances.geofencing_html_template.setData(strgeofencing_html_template);
                    //$('#geofencing_email').val('');
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
}

$(document).on('click', '#resetTemplates', function (e) {

    webix.confirm({
        title: "Confirm", text: "Do you want to reset to default templates?", width: 400, callback: function (result) {
            if (result == true) {
                CKEDITOR.instances.L8F2.setData("<div style=\"background-color:#3535CD;color:#FFFFFF;font-family: helvetica, arial, sans-serif; font-size:10px;text-align:center;padding-top:5px;padding-bottom:5px\">%CLASSIFY%</div><br>");
                $('#L8F3').val("************************************************\n%CLASSIFY%\n************************************************\n");
            }
        }
    });
});

$(document).on('click', '.workspace_template_reset', function (e) {
    $resetBtn = this;
    webix.confirm({
        title: "Confirm", text: "Do you want to reset to default template?", width: 400, callback: function (result) {
            if (result == true) {
                $id = $resetBtn.getAttribute("data_id");
                if ($id == "1") {
                    $("#workspace_template_1_subject").val("Workspace Created: $WORKSPACENAME$");
                    CKEDITOR.instances["workspace_template_1"].setData(fnGetWorkspaceEmailTempate($id));
                }
                else if ($id == "2") {
                    $("#workspace_template_2_subject").val("You have been added as a member to Workspace: $WORKSPACENAME$");
                    CKEDITOR.instances["workspace_template_2"].setData(fnGetWorkspaceEmailTempate($id));
                }
                else if ($id == "3") {
                    $("#workspace_template_3_subject").val("File Uploaded To: $WORKSPACENAME$");
                    CKEDITOR.instances["workspace_template_3"].setData(fnGetWorkspaceEmailTempate($id));
                }
                else if ($id == "4") {
                    $("#workspace_template_4_subject").val("Find Attached Documents");
                    CKEDITOR.instances["workspace_template_4"].setData(fnGetWorkspaceEmailTempate($id));
                }
                else if ($id == "5") {
                    $("#workspace_template_5_subject").val("Workspace Notification");
                    CKEDITOR.instances["workspace_template_5"].setData(fnGetWorkspaceEmailTempate($id));
                }
                else if ($id == "6") {
                    $("#workspace_template_6_subject").val("You have been added as a reviewer to Workspace: $WORKSPACENAME$");
                    CKEDITOR.instances["workspace_template_6"].setData(fnGetWorkspaceEmailTempate($id));
                }
            }
        }
    });
});

function fnGetWorkspaceEmailTempate($id) {
    $strReturnValue = "";
    if ($id == "1") {
        $strReturnValue = "<p>Hi,</p><p>I have created a Secure Workspace in our Corporate Collaboration Platform. I have added you as a member to this workspace.</p><p><strong>Workspace Name</strong>: $WORKSPACENAME$</p><p><strong>Description</strong>: $WORKSPACEDESCRIPTION$</p><p>You can access this workspace with the following URL. Click the URL or copy and paste into your browser.</p><p><strong>Workspace URL</strong>: <a href=\"$WORKSPACEURL$\">$WORKSPACEURL$</a></p><p>&nbsp;</p><p>$SIGNATURE$</p>";
    }
    else if ($id == "2") {
        $strReturnValue = "<p>Hi,</p><p>I have created a Secure Workspace in our Corporate Collaboration Platform. I have added you as a member to this workspace.</p><p><strong>Workspace Name</strong>: $WORKSPACENAME$</p><p><strong>Description</strong>: $WORKSPACEDESCRIPTION$</p><p>You can access this workspace with the following URL. Click the URL or copy and paste into your browser.</p><p><strong>Workspace URL</strong>: <a href=\"$WORKSPACEURL$\">$WORKSPACEURL$</a></p><p>&nbsp;</p><p>$SIGNATURE$</p>";
    }
    else if ($id == "3") {
        $strReturnValue = "<p>Hi,</p><p>I have added files to the following Secure Workspace</p><p><strong>Folder where files are added/updated:&nbsp;</strong><br />$FOLDER_LOCATION$</p><p><strong>File/s Added/Updated:<br />​</strong>$FILE_LIST$</p><p>&nbsp;</p><p>You can access this workspace with the following URL. Click the URL or copy and paste into your browser.</p><p><strong>Workspace URL</strong>: <a href=\"$WORKSPACEURL$\">$WORKSPACEURL$</a></p><p>$SIGNATURE$</p>";
    }
    else if ($id == "4") {
        $strReturnValue = "<p>Hi,</p><p>I have attached the following documents to this email</p><p><strong>Attached Documents</strong>:<br />$FILE_LIST$</p><p>$SIGNATURE$</p>";
    }
    else if ($id == "5") {
        $strReturnValue = "<p><strong>Notification From</strong>:<br />$NOTIFICATION_FROM$</p><p><strong>Event</strong>:<br />$ACTION$</p><p><strong>Document Path</strong>:<br />$FILE_PATH_NAME$</p><p><strong>Workspace Name</strong>:<br/>$WORKSPACENAME$</p>";
    }
    else if ($id == "6") {
        $strReturnValue = "<p>Hi,</p><p>I have added you to <strong>review</strong> files in a workspace.</p><p><strong>Workspace Name</strong>: $WORKSPACENAME$</p><p><strong>Description</strong>: $WORKSPACEDESCRIPTION$</p><p>You can access this workspace with the following URL. Click the URL or copy and paste into your browser.</p><p><strong>Workspace URL</strong>: <a href=\"$WORKSPACEURL$\">$WORKSPACEURL$</a></p><p>&nbsp;</p><p>$SIGNATURE$</p>";
    }
    return $strReturnValue;
}


// This function gets the standard Galaxkey header and footer templates
function fnGetTemplatesForNotifications() {
    var strContent = '';
    strContent += "    <table align=\"center\" width=\"100%\" style=\"border: none; background-color: #ffffff; text-align: center;padding: 30px;\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
    strContent += "        <tr>";
    strContent += "            <td>";
    strContent += "                <table align=\"center\" style=\"border: none; text-align: left;\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
    strContent += "                    <tr>";
    strContent += "                        <td>";
    strContent += "                            <table style=\"border: none;\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
    strContent += "                                <tr>";
    strContent += "                                    <td colspan=\"2\">";
    strContent += "                                        <table width=\"100%\" style=\"border: none; border-collapse:collapse; font-family: Helvetica, Arial, sans-serif; font-size:18px; color: #000000;\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
    strContent += "											<tr>";
    strContent += "												<td>";
    strContent += "													<a href=\"http://www.galaxkey.com\"><img alt=\"Email from Galaxkey\" src=\"http://www.galaxkey.com/required/smalllogo.jpg\"/></a>";
    strContent += "												</td>";
    strContent += "											</tr>";
    strContent += "										</table>";
    strContent += "                                    </td>";
    strContent += "                                </tr>";
    strContent += "                                <tr>";
    strContent += "                                    <td style=\"text-align:center;border-bottom: 3px solid #cf3533; border-top: 3px solid #cf3533; background-color: #ffffff;\" valign=\"top\">";
    strContent += "                                        <table background=\"#ffffff\" style=\"background-color: #ffffff; border: none; border-collapse:collapse; font-family: Helvetica, Arial, sans-serif; font-size:14px; color: #333333;\" cellpadding=\"0\" cellspacing=\"0\">";
    strContent += "                                            <tr>";
    strContent += "                                                <td valign=\"top\" style=\"text-align:left;padding: 30px;\">";
    strContent += "													<p>";
    strContent += "													$EMAIL_MESSAGE$";
    strContent += "                                                    </p>";
    strContent += "												</td>";
    strContent += "                                            </tr>";
    strContent += "                                            <tr>";
    strContent += "	                                            <td colspan=\"2\" style=\"text-align:center;\"><span style=\"color:#000000;font-size:10px\">PLEASE DO NOT REPLY TO THIS MAIL. THIS IS AN AUTO GENERATED MAIL AND REPLIES TO THIS EMAIL ID ARE NOT ATTENDED</span><br/><br/></td>";
    strContent += "                                            </tr>";
    strContent += "                                        </table>";
    strContent += "                                    </td>";
    strContent += "                                </tr>";
    strContent += "                                <tr>";
    strContent += "                                    <td colspan=\"2\" style=\"background-color:#f6f6f6; padding:0px 0 10px 0;color:rgb(187,189,191);\">";
    strContent += "                                        <table width=\"100%\" cellspacing=\"0\" cellpadding=\"10\" style=\"border: 0; border-collapse:collapse; border: none; border-collapse:collapse; font-family: Helvetica, Arial, sans-serif; font-size:12px; color: #333333;\">";
    strContent += "                                            <tr>";
    strContent += "                                                <td style=\"width:50%\" valign=\"top\">";
    strContent += "                                                    <p style=\"margin:0;padding:0;\">";
    strContent += "                                                    </p>";
    strContent += "                                                </td>";
    strContent += "                                            </tr>";
    strContent += "                                            ";
    strContent += "                                        </table>";
    strContent += "                                    </td>";
    strContent += "                                </tr>";
    strContent += "                            </table>";
    strContent += "                        </td>";
    strContent += "                    </tr>";
    strContent += "                </table>";
    strContent += "            </td>";
    strContent += "        </tr>";
    strContent += "    </table>";
    strContent += "</body>";
    strContent += "</html>";


    CKEDITOR.instances.notification_email_template.setData(strContent);
}


function fnGetCustomInviteTemplate() {

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: '/CorporateConfiguration/StandardTemplates',
        data: '',
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = jSon['result'];
                if (bResult == false) {
                    $("#dialogMessage").text(jSon['message']);
                    $("#dialog-message").dialog('open');
                }
                else {
                    var strInvitationTextTemplate = jSon['invitation_text_template'];
                    $('#custom_invitation_email').val(strInvitationTextTemplate);
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });


}

function updateTips(t) {
    $(".validateTips")
      .text(t)
      .addClass("ui-state-highlight");
    setTimeout(function () {
        $(".validateTips").removeClass("ui-state-highlight", 1500);
    }, 500);
};

function checkLength(o, n, min, max) {
    if (o.val().length > max || o.val().length < min) {
        o.addClass("ui-state-error");
        updateTips("Length of " + n + " must be between " +
          min + " and " + max + ".");
        return false;
    } else {
        return true;
    }
};

function checkRegexp(o, regexp, n) {
    if (!(regexp.test(o.val()))) {
        o.addClass("ui-state-error");
        updateTips(n);
        return false;
    } else {
        return true;
    }
};


$("#corpconfform").submit(function (e) {
    e.preventDefault();
    //Lets read the classification JSON
    var strClassificationString = "{";
    var strAdditionalConfiguration = "{";
    if (bEnableClassification == true) {
        var htmlTemplate = "";
        if ($("#L8F2").val() != undefined) {
            htmlTemplate = CKEDITOR.instances.L8F2.getData();
        }
        var textTemplate = $("#L8F3").val();

        htmlTemplate = Base64.encode(htmlTemplate);
        textTemplate = Base64.encode(textTemplate);

        var classification = "";
        if (classificationJSON != undefined) {
            classification = Base64.encode(JSON.stringify(classificationJSON));
        }

        strClassificationString += "\"L8\":{";
        strClassificationString += "\"L8F1\":\"" + $("#L8F1").prop('checked') + "\",";
        strClassificationString += "\"L8F2\":\"" + htmlTemplate + "\",";
        strClassificationString += "\"L8F3\":\"" + textTemplate + "\",";
        strClassificationString += "\"L8F4\":\"" + $("#L8F4").val() + "\",";
        strClassificationString += "\"L8F5\":\"" + classification + "\",";
        strClassificationString += "\"L8F6\":\"" + $("#L8F6").prop('checked') + "\",";
        strClassificationString += "\"L8F7\":\"" + $("#L8F7").prop('checked') + "\"";
        strClassificationString += "}";
    }
    strClassificationString += "}";
    $("#classification").val(Base64.encode(strClassificationString));


    /*25_10_2018_RJS*/
    // Check for Secure Collaboration Settings
    var strSecureCollaboration = "{";
    if (bEnableSecureCollaboration == true) {
        strSecureCollaboration += "\"L11\":{";
        strSecureCollaboration += "\"L11F1\":\"" + Base64.encode($("#L11F1").val()) + "\",";
        strSecureCollaboration += "\"L11F2\":\"" + Base64.encode($("#L11F2").val()) + "\",";
        strSecureCollaboration += "\"L11F3\":\"" + Base64.encode($("#L11F3").val()) + "\",";
        strSecureCollaboration += "\"L11F4\":\"" + Base64.encode($("#L11F4").val()) + "\",";
        strSecureCollaboration += "\"L11F5\":\"" + Base64.encode($("#L11F5").val()) + "\",";
        strSecureCollaboration += "\"L11F8\":\"" + Base64.encode($("#L11F8").val()) + "\",";
        strSecureCollaboration += "\"L11F9\":\"" + Base64.encode($("#L11F9").val()) + "\",";
        strSecureCollaboration += "\"L11F10\":\"" + $("#L11F10").prop('checked').toString() + "\",";
        strSecureCollaboration += "\"L11F11\":\"" + $("#L11F11").prop('checked').toString() + "\",";
        strSecureCollaboration += "\"L11F17\":\"" + $("#L11F17").prop('checked').toString() + "\",";
        strSecureCollaboration += "\"L11F18\":\"" + $("#L11F18").prop('checked').toString() + "\",";
        strSecureCollaboration += "\"L11F19\":\"" + $("#L11F19").prop('checked').toString() + "\",";
        strSecureCollaboration += "\"L11F20\":\"" + $("#L11F20").prop('checked').toString() + "\",";
        strSecureCollaboration += "\"L11F12\":\"" + Base64.encode($("#L11F12").val()) + "\",";

        // Read the email templates
        $workspace_template_1 = CKEDITOR.instances.workspace_template_1.getData();
        $workspace_template_2 = CKEDITOR.instances.workspace_template_2.getData();
        $workspace_template_3 = CKEDITOR.instances.workspace_template_3.getData();
        $workspace_template_4 = CKEDITOR.instances.workspace_template_4.getData();
        $workspace_template_5 = CKEDITOR.instances.workspace_template_5.getData();
        $workspace_template_6 = CKEDITOR.instances.workspace_template_6.getData();
        $workspace_template_1_subject = $("#workspace_template_1_subject").val();
        $workspace_template_2_subject = $("#workspace_template_2_subject").val();
        $workspace_template_3_subject = $("#workspace_template_3_subject").val();
        $workspace_template_4_subject = $("#workspace_template_4_subject").val();
        $workspace_template_5_subject = $("#workspace_template_5_subject").val();
        $workspace_template_6_subject = $("#workspace_template_6_subject").val();


        $workspace_templates = "{";
        $workspace_templates += "\"1\":{";
        $workspace_templates += "\"subject\":\"" + b64EncodeUnicode($workspace_template_1_subject) + "\",";
        $workspace_templates += "\"body\":\"" + b64EncodeUnicode($workspace_template_1) + "\"";
        $workspace_templates += "},";
        $workspace_templates += "\"2\":{";
        $workspace_templates += "\"subject\":\"" + b64EncodeUnicode($workspace_template_2_subject) + "\",";
        $workspace_templates += "\"body\":\"" + b64EncodeUnicode($workspace_template_2) + "\"";
        $workspace_templates += "},";
        $workspace_templates += "\"3\":{";
        $workspace_templates += "\"subject\":\"" + b64EncodeUnicode($workspace_template_3_subject) + "\",";
        $workspace_templates += "\"body\":\"" + b64EncodeUnicode($workspace_template_3) + "\"";
        $workspace_templates += "},";
        $workspace_templates += "\"4\":{";
        $workspace_templates += "\"subject\":\"" + b64EncodeUnicode($workspace_template_4_subject) + "\",";
        $workspace_templates += "\"body\":\"" + b64EncodeUnicode($workspace_template_4) + "\"";
        $workspace_templates += "},";
        $workspace_templates += "\"5\":{";
        $workspace_templates += "\"subject\":\"" + b64EncodeUnicode($workspace_template_5_subject) + "\",";
        $workspace_templates += "\"body\":\"" + b64EncodeUnicode($workspace_template_5) + "\"";
        $workspace_templates += "},";
        $workspace_templates += "\"6\":{";
        $workspace_templates += "\"subject\":\"" + b64EncodeUnicode($workspace_template_6_subject) + "\",";
        $workspace_templates += "\"body\":\"" + b64EncodeUnicode($workspace_template_6) + "\"";
        $workspace_templates += "}";
        $workspace_templates += "}";

        strSecureCollaboration += "\"L11F13\":\"" + b64EncodeUnicode($workspace_templates) + "\",";
        strSecureCollaboration += "\"L11F14\":\"" + Base64.encode($("#L11F14").val()) + "\",";
        strSecureCollaboration += "\"L11F15\":\"" + Base64.encode($("#L11F15").val()) + "\",";

        $GDPRPolicy = CKEDITOR.instances.L11F16.getData();
        $GDPRPolicy = b64EncodeUnicode($GDPRPolicy);
        strSecureCollaboration += "\"L11F16\":\"" + $GDPRPolicy + "\"";
        

        strSecureCollaboration += "}";
    }
    strSecureCollaboration += "}";
    $("#SecureCollaborationJSON").val(Base64.encode(strSecureCollaboration));
    /*25_10_2018_RJS*/

    // Add the additional configurations to the additionalConfigurations field
    strAdditionalConfiguration += "\"L5\":{";
    if ($("#L5F2") != undefined && $("#L5F2").prop('checked') != undefined) {
        strAdditionalConfiguration += "\"L5F2\":\"" + $("#L5F2").prop('checked') + "\"";
    }
    else {
        strAdditionalConfiguration += "\"L5F2\":\"false\"";
    }
    strAdditionalConfiguration += "},";
    strAdditionalConfiguration += "\"L13\":{";
    if ($("#L13F1") != undefined && $("#L13F1").prop('checked') != undefined) {
        strAdditionalConfiguration += "\"L13F1\":\"" + $("#L13F1").prop('checked') + "\",";
    }
    else {
        strAdditionalConfiguration += "\"L13F1\":\"false\",";
    }

    if ($("#L13F2") != undefined && $("#L13F2").val() != undefined) {
        strAdditionalConfiguration += "\"L13F2\":\"" + Base64.encode($("#L13F2").val()) + "\"";
    }
    else {
        strAdditionalConfiguration += "\"L13F2\":\"" + Base64.encode('') + "\"";
    }
    strAdditionalConfiguration += "},";


    strAdditionalConfiguration += "\"L23\":{";
    if ($("#L23F2") != undefined && $("#L23F2").val() != undefined) {
        strAdditionalConfiguration += "\"L23F2\":\"" + Base64.encode($("#L23F2").val()) + "\",";
    }
    else {
        strAdditionalConfiguration += "\"L23F2\":\"" + Base64.encode('3') + "\",";
    }

    if ($("#L23F3") != undefined && $("#L23F3").val() != undefined) {
        strAdditionalConfiguration += "\"L23F3\":\"" + Base64.encode($("#L23F3").val()) + "\"";
    }
    else {
        strAdditionalConfiguration += "\"L23F3\":\"" + Base64.encode('15') + "\"";
    }
    strAdditionalConfiguration += "}";
    strAdditionalConfiguration += "}";
    $("#AdditionalConfigurationJSON").val(Base64.encode(strAdditionalConfiguration));


    var form = this;
    form.submit();
});

$(document).ready(function () {

    if ($$("classficationListing") != null) {
        $$("classficationListing").clearAll();
    }
    if (bEnableClassification == true) {
        $("#EXT_L8").show(250);
        $("#li_conf_classification").show(250);
        if (classsificationDataJSON.L8 != undefined && classsificationDataJSON.L8 != '') {
            if (classsificationDataJSON.L8.L8F1 != undefined && classsificationDataJSON.L8.L8F1 != '') {
                $("#L8F1").attr('checked', (classsificationDataJSON.L8.L8F1.toLowerCase() === 'true'));
                if (classsificationDataJSON.L8.L8F2 != undefined) {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.L8F2.setData(Base64.decode(classsificationDataJSON.L8.L8F2));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.L8F2.setData("<div style=\"background-color:#3535CD;color:#FFFFFF;font-family: helvetica, arial, sans-serif; font-size:10px;text-align:center;padding-top:5px;padding-bottom:5px\">%CLASSIFY%</div><br>");
                    });
                }
            }
            if (classsificationDataJSON.L8.L8F6 != undefined && classsificationDataJSON.L8.L8F6 != '') {
                $("#L8F6").attr('checked', (classsificationDataJSON.L8.L8F6.toLowerCase() === 'true'));
            }
            if (classsificationDataJSON.L8.L8F7 != undefined && classsificationDataJSON.L8.L8F7 != '') {
                $("#L8F7").attr('checked', (classsificationDataJSON.L8.L8F7.toLowerCase() === 'true'));
            }

            if (classsificationDataJSON.L8.L8F3 != undefined && classsificationDataJSON.L8.L8F3 != '') {
                $('#L8F3').val(Base64.decode(classsificationDataJSON.L8.L8F3));
            }
            if (classsificationDataJSON.L8.L8F5 != undefined && classsificationDataJSON.L8.L8F5 != '') {
                var strClassificationJSON = Base64.decode(classsificationDataJSON.L8.L8F5);
                if (strClassificationJSON != undefined && strClassificationJSON != '') {
                    classificationJSON = $.parseJSON(strClassificationJSON);
                }
                if ($$("classficationListing") != undefined && $$("classficationListing") != '') {
                    $$("classficationListing").clearAll();
                    $$("classficationListing").parse(classificationJSON);
                }
            }
            if (classsificationDataJSON.L8.L8F4 != undefined && classsificationDataJSON.L8.L8F4 != '') {
                $('#L8F4').val(classsificationDataJSON.L8.L8F4);
            }
        }
        else {
                CKEDITOR.on('instanceReady', function () {
                    CKEDITOR.instances.L8F2.setData("<div style=\"background-color:#3535CD;color:#FFFFFF;font-family: helvetica, arial, sans-serif; font-size:10px;text-align:center;padding-top:5px;padding-bottom:5px\">%CLASSIFY%</div><br>");
                });
                $('#L8F3').val("************************************************\n%CLASSIFY%\n************************************************\n");
            }
    }
    else
    {
        $("#EXT_L8").hide();
        $("#li_conf_classification").hide();
    }

    /* CUSTOM SECURED EMAIL TEMPLATE */
    var strCustomTemplate = $('#custom_encryption_email_html').val();
    if (strCustomTemplate != undefined && strCustomTemplate != "") {
        $("#checkBoxCustomSecuredEmail_data").show();
        $('#checkBoxCustomSecuredEmail').attr('checked', true);
    }
    else {
        $("#checkBoxCustomSecuredEmail_data").hide();
        $('#checkBoxCustomSecuredEmail').attr('checked', false);
    }; 
    $("#checkBoxCustomSecuredEmail").click(function () {

        var satisfied = $('#checkBoxCustomSecuredEmail').prop('checked');
        if (satisfied != undefined && satisfied == true) {
            $("#checkBoxCustomSecuredEmail_data").show();
            $('#checkBoxCustomSecuredEmail').attr('checked', true);
            fnGetTemplates();
        }
        else {
            $("#checkBoxCustomSecuredEmail_data").hide();
            $('#checkBoxCustomSecuredEmail').attr('checked', false);
            CKEDITOR.instances.custom_encryption_email_html.setData("");
            $('#custom_encryption_email_text').val("");
        }

    });
    /* CUSTOM SECURED EMAIL TEMPLATE */


    /* CUSTOM INVITATION EMAIL TEMPLATE */
    var strInvitationEmailTemplate = $('#custom_invitation_email').val();
    if (strInvitationEmailTemplate != undefined && strInvitationEmailTemplate != "") {
        $("#checkBoxInvitationEmail_data").show();
        $('#checkBoxInvitationEmail').attr('checked', true);
    }
    else {
        $("#checkBoxInvitationEmail_data").hide();
        $('#checkBoxInvitationEmail').attr('checked', false);
    };
    $("#checkBoxInvitationEmail").click(function () {

        var satisfied = $('#checkBoxInvitationEmail').prop('checked');
        if (satisfied != undefined && satisfied == true) {
            $("#checkBoxInvitationEmail_data").show();
            $('#checkBoxInvitationEmail').attr('checked', true);
            fnGetCustomInviteTemplate();
        }
        else {
            $("#checkBoxInvitationEmail_data").hide();
            $('#checkBoxInvitationEmail').attr('checked', false);
            $('#custom_invitation_email').val("");
        }

    });
    /* CUSTOM INVITATION EMAIL TEMPLATE */


    /* CUSTOM GEOFENCE EMAIL TEMPLATE */
    var strGeoFencingTemplateHtml = $('#geofencing_html_template').val();
    if (strGeoFencingTemplateHtml != undefined && strGeoFencingTemplateHtml != "") {
        $("#checkBoxGeoFencingTemplate_data").show();
        $('#checkBoxGeoFencingTemplate').attr('checked', true);
    }
    else {
        $("#checkBoxGeoFencingTemplate_data").hide();
        $('#checkBoxGeoFencingTemplate').attr('checked', false);
    };

    $("#checkBoxGeoFencingTemplate").click(function () {

        var satisfied = $('#checkBoxGeoFencingTemplate').prop('checked');
        if (satisfied != undefined && satisfied == true) {
            $("#checkBoxGeoFencingTemplate_data").show(250);
            fnGetTemplatesForGeoFencing();
        }
        else {
            $("#checkBoxGeoFencingTemplate_data").hide(250);
            CKEDITOR.instances.geofencing_html_template.setData("");
        }

    });
    /* CUSTOM GEOFENCE EMAIL TEMPLATE */



    /* CUSTOM NOTIFICATION EMAIL TEMPLATE */
    var strNotificationsTemplateHtml = $('#notification_email_template').val();
    if (strNotificationsTemplateHtml != undefined && strNotificationsTemplateHtml != "") {
        $("#checkBoxNotificationsTemplate_data").show();
        $('#checkBoxNotificationsTemplate').attr('checked', true);
    }
    else {
        $("#checkBoxNotificationsTemplate_data").hide();
        $('#checkBoxNotificationsTemplate').attr('checked', false);
    };

    $("#checkBoxNotificationsTemplate").click(function () {

        var satisfied = $('#checkBoxNotificationsTemplate').prop('checked');
        if (satisfied != undefined && satisfied == true) {
            $("#checkBoxNotificationsTemplate_data").show(250);
            fnGetTemplatesForNotifications();
        }
        else {
            $("#checkBoxNotificationsTemplate_data").hide(250);
            CKEDITOR.instances.notification_email_template.setData("");
        }

    });
    /* CUSTOM NOTIFICATION EMAIL TEMPLATE */


    /*25_10_2018_RJS*/
    if (bEnableSecureCollaboration == true) {
        $("#EXT_L11").show(250);
        $("#li_conf_workspace").show(250);
        if (SecureCollaborationJSON.L11 != undefined) {

            if (SecureCollaborationJSON.L11.L11F1 != undefined && SecureCollaborationJSON.L11.L11F1 != '') {
                $('#L11F1').val(Base64.decode(SecureCollaborationJSON.L11.L11F1));
            }
            if (SecureCollaborationJSON.L11.L11F2 != undefined && SecureCollaborationJSON.L11.L11F2 != '') {
                $('#L11F2').val(Base64.decode(SecureCollaborationJSON.L11.L11F2));
            }
            if (SecureCollaborationJSON.L11.L11F3 != undefined && SecureCollaborationJSON.L11.L11F3 != '') {
                $("#L11F3").val(Base64.decode(SecureCollaborationJSON.L11.L11F3));
            }
            if (SecureCollaborationJSON.L11.L11F4 != undefined && SecureCollaborationJSON.L11.L11F4 != '') {
                $('#L11F4').val(Base64.decode(SecureCollaborationJSON.L11.L11F4));
            }
            if (SecureCollaborationJSON.L11.L11F5 != undefined && SecureCollaborationJSON.L11.L11F5 != '') {
                $('#L11F5').val(Base64.decode(SecureCollaborationJSON.L11.L11F5));
            }


            if (SecureCollaborationJSON.L11.L11F8 != undefined && SecureCollaborationJSON.L11.L11F8 != '') {
                $('#L11F8').val(Base64.decode(SecureCollaborationJSON.L11.L11F8));
            }
            if (SecureCollaborationJSON.L11.L11F9 != undefined && SecureCollaborationJSON.L11.L11F9 != '') {
                $('#L11F9').val(Base64.decode(SecureCollaborationJSON.L11.L11F9));
            }
            if (SecureCollaborationJSON.L11.L11F10 != undefined && SecureCollaborationJSON.L11.L11F10 != '') {
                if (SecureCollaborationJSON.L11.L11F10 == 'false') {
                    $('#L11F10').attr('checked', false);
                }
                else {
                    $('#L11F10').attr('checked', true);
                }
            }
            if (SecureCollaborationJSON.L11.L11F11 != undefined && SecureCollaborationJSON.L11.L11F11 != '') {
                if (SecureCollaborationJSON.L11.L11F11 == 'false') {
                    $('#L11F11').attr('checked', false);
                }
                else {
                    $('#L11F11').attr('checked', true);
                }
            }
            if (SecureCollaborationJSON.L11.L11F17 != undefined && SecureCollaborationJSON.L11.L11F17 != '') {
                if (SecureCollaborationJSON.L11.L11F17 == 'false') {
                    $('#L11F17').attr('checked', false);
                }
                else {
                    $('#L11F17').attr('checked', true);
                }
            }
            if (SecureCollaborationJSON.L11.L11F18 != undefined && SecureCollaborationJSON.L11.L11F18 != '') {
                if (SecureCollaborationJSON.L11.L11F18 == 'false') {
                    $('#L11F18').attr('checked', false);
                }
                else {
                    $('#L11F18').attr('checked', true);
                }
            }
            if (SecureCollaborationJSON.L11.L11F19 != undefined && SecureCollaborationJSON.L11.L11F19 != '') {
                if (SecureCollaborationJSON.L11.L11F19 == 'false') {
                    $('#L11F19').attr('checked', false);
                }
                else {
                    $('#L11F19').attr('checked', true);
                }
            }
            if (SecureCollaborationJSON.L11.L11F20 != undefined && SecureCollaborationJSON.L11.L11F20 != '') {
                if (SecureCollaborationJSON.L11.L11F20 == 'false') {
                    $('#L11F20').attr('checked', false);
                }
                else {
                    $('#L11F20').attr('checked', true);
                }
            }
            if (SecureCollaborationJSON.L11.L11F12 != undefined && SecureCollaborationJSON.L11.L11F12 != '') {
                $('#L11F12').val(Base64.decode(SecureCollaborationJSON.L11.L11F12));
            }
            if (SecureCollaborationJSON.L11.L11F13 != undefined && SecureCollaborationJSON.L11.L11F13 != '') {
                $emailTemplatesJSON = JSON.parse(b64DecodeUnicode(SecureCollaborationJSON.L11.L11F13));
                if ($emailTemplatesJSON["1"]["subject"] != undefined && $emailTemplatesJSON["1"]["subject"] != '') {
                    $("#workspace_template_1_subject").val(b64DecodeUnicode($emailTemplatesJSON["1"]["subject"]));
                }
                else {
                    $("#workspace_template_1_subject").val("Workspace Created: $WORKSPACENAME$");
                }
                if ($emailTemplatesJSON["2"]["subject"] != undefined && $emailTemplatesJSON["2"]["subject"] != '') {
                    $("#workspace_template_2_subject").val(b64DecodeUnicode($emailTemplatesJSON["2"]["subject"]));
                }
                else {
                    $("#workspace_template_2_subject").val("You have been added as a member to Workspace: $WORKSPACENAME$");
                }
                if ($emailTemplatesJSON["3"]["subject"] != undefined && $emailTemplatesJSON["3"]["subject"] != '') {
                    $("#workspace_template_3_subject").val(b64DecodeUnicode($emailTemplatesJSON["3"]["subject"]));
                }
                else {
                    $("#workspace_template_3_subject").val("File Uploaded To: $WORKSPACENAME$");
                }
                if ($emailTemplatesJSON["4"]["subject"] != undefined && $emailTemplatesJSON["4"]["subject"] != '') {
                    $("#workspace_template_4_subject").val(b64DecodeUnicode($emailTemplatesJSON["4"]["subject"]));
                }
                else {
                    $("#workspace_template_4_subject").val("Find Attached Documents");
                }
                if ($emailTemplatesJSON["5"] != undefined && $emailTemplatesJSON["5"]["subject"] != undefined && $emailTemplatesJSON["5"]["subject"] != '') {
                    $("#workspace_template_5_subject").val(b64DecodeUnicode($emailTemplatesJSON["5"]["subject"]));
                }
                else {
                    $("#workspace_template_5_subject").val("Workspace Notification");
                }
                if ($emailTemplatesJSON["6"] != undefined && $emailTemplatesJSON["6"]["subject"] != undefined && $emailTemplatesJSON["6"]["subject"] != '') {
                    $("#workspace_template_6_subject").val(b64DecodeUnicode($emailTemplatesJSON["6"]["subject"]));
                }
                else {
                    $("#workspace_template_6_subject").val("You have been added as a reviewer to Workspace: $WORKSPACENAME$");
                }

                if ($emailTemplatesJSON["1"]["body"] != undefined && $emailTemplatesJSON["1"]["body"] != '') {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_1.setData(b64DecodeUnicode($emailTemplatesJSON["1"]["body"]));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_1.setData(fnGetWorkspaceEmailTempate("1"));
                    });
                }
                if ($emailTemplatesJSON["2"]["body"] != undefined && $emailTemplatesJSON["2"]["body"] != '') {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_2.setData(b64DecodeUnicode($emailTemplatesJSON["2"]["body"]));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_2.setData(fnGetWorkspaceEmailTempate("2"));
                    });
                }
                if ($emailTemplatesJSON["3"]["body"] != undefined && $emailTemplatesJSON["3"]["body"] != '') {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_3.setData(b64DecodeUnicode($emailTemplatesJSON["3"]["body"]));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_3.setData(fnGetWorkspaceEmailTempate("3"));
                    });
                }
                if ($emailTemplatesJSON["4"]["body"] != undefined && $emailTemplatesJSON["4"]["body"] != '') {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_4.setData(b64DecodeUnicode($emailTemplatesJSON["4"]["body"]));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_4.setData(fnGetWorkspaceEmailTempate("4"));
                    });
                }
                if ($emailTemplatesJSON["5"] != undefined && $emailTemplatesJSON["5"]["body"] != undefined && $emailTemplatesJSON["5"]["body"] != '') {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_5.setData(b64DecodeUnicode($emailTemplatesJSON["5"]["body"]));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_5.setData(fnGetWorkspaceEmailTempate("5"));
                    });
                }
                if ($emailTemplatesJSON["6"] != undefined && $emailTemplatesJSON["6"]["body"] != undefined && $emailTemplatesJSON["6"]["body"] != '') {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_6.setData(b64DecodeUnicode($emailTemplatesJSON["6"]["body"]));
                    });
                }
                else {
                    CKEDITOR.on('instanceReady', function () {
                        CKEDITOR.instances.workspace_template_6.setData(fnGetWorkspaceEmailTempate("6"));
                    });
                }
            }
            if (SecureCollaborationJSON.L11.L11F14 != undefined && SecureCollaborationJSON.L11.L11F14 != '') {
                $('#L11F14').val(Base64.decode(SecureCollaborationJSON.L11.L11F14));
            }
            if (SecureCollaborationJSON.L11.L11F15 != undefined && SecureCollaborationJSON.L11.L11F15 != '') {
                $('#L11F15').val(Base64.decode(SecureCollaborationJSON.L11.L11F15));
            }
            if (SecureCollaborationJSON.L11.L11F16 != undefined && SecureCollaborationJSON.L11.L11F16 != '') {
                CKEDITOR.on('instanceReady', function () {
                    CKEDITOR.instances.L11F16.setData(b64DecodeUnicode(SecureCollaborationJSON.L11.L11F16));
                });
            }
        }
        else {
            // Lets set the default values for the email templates
            CKEDITOR.on('instanceReady', function () {
                CKEDITOR.instances.workspace_template_1.setData(fnGetWorkspaceEmailTempate("1"));
            });
            CKEDITOR.on('instanceReady', function () {
                CKEDITOR.instances.workspace_template_2.setData(fnGetWorkspaceEmailTempate("2"));
            });
            CKEDITOR.on('instanceReady', function () {
                CKEDITOR.instances.workspace_template_3.setData(fnGetWorkspaceEmailTempate("3"));
            });
            CKEDITOR.on('instanceReady', function () {
                CKEDITOR.instances.workspace_template_4.setData(fnGetWorkspaceEmailTempate("4"));
            });
            CKEDITOR.on('instanceReady', function () {
                CKEDITOR.instances.workspace_template_5.setData(fnGetWorkspaceEmailTempate("5"));
            });
            CKEDITOR.on('instanceReady', function () {
                CKEDITOR.instances.workspace_template_6.setData(fnGetWorkspaceEmailTempate("6"));
            });
        }
    }
    else {
        if ($("#EXT_L11") != undefined) {
            $("#EXT_L11").hide();
        }
        if ($("#li_conf_workspace") != undefined) {
            $("#li_conf_workspace").hide();
        }

    }
    /*25_10_2018_RJS*/

    if (additionalConfigurationJSON.L5 != undefined) {
        if (additionalConfigurationJSON.L5.L5F2 != undefined
            && additionalConfigurationJSON.L5.L5F2 != ''
            && $('#L5F2').length > 0
            ) {
            if (additionalConfigurationJSON.L5.L5F2 == 'false') {
                $('#L5F2').attr('checked', false);
            }
            else {
                $('#L5F2').attr('checked', true);
            }
        }
    }
    if (additionalConfigurationJSON.L13 != undefined) {
        if (additionalConfigurationJSON.L13.L13F1 != undefined && additionalConfigurationJSON.L13.L13F1 != '' && $('#L13F1').length > 0) {
            if (additionalConfigurationJSON.L13.L13F1 == 'false') {
                $('#L13F1').attr('checked', false);
            }
            else {
                $('#L13F1').attr('checked', true);
            }
        }
        if (additionalConfigurationJSON.L13.L13F2 != undefined && additionalConfigurationJSON.L13.L13F2 != '' && $('#L13F2').length > 0) {
            $('#L13F2').val(Base64.decode(additionalConfigurationJSON.L13.L13F2));
        }
    }

    if (additionalConfigurationJSON.L23 != undefined) {
        if (additionalConfigurationJSON.L23.L23F2 != undefined && additionalConfigurationJSON.L23.L23F2 != '' && $('#L23F2').length > 0) {
            $('#L23F2').val(Base64.decode(additionalConfigurationJSON.L23.L23F2));
        }
        if (additionalConfigurationJSON.L23.L23F3 != undefined && additionalConfigurationJSON.L23.L23F3 != '' && $('#L23F3').length > 0) {
            $('#L23F3').val(Base64.decode(additionalConfigurationJSON.L23.L23F3));
        }
    }
    // store the currently selected tab in the hash value
    $("ul.nav-tabs > li > a").on("shown.bs.tab", function (e) {
        sessionStorage.setItem("configuration_tab", $(this).attr('id'));
    });

    // on load of the page: switch to the currently selected tab
    if (sessionStorage.getItem("configuration_tab") != null) {
        var clickeId = sessionStorage.getItem("configuration_tab");
        $("#" + clickeId).click();
    }

    
});

