﻿var arrFeaturesList = Array();
var changeJSON = Array();
var bDirtyFlag = false;
var strSelectedGroup = 'DEFAULT GROUP';

// This function loads the JSON data in the controls
function fnLoadJsonData(jsonData) {
    classificationJSON = Array();
    if ($$("policyListing") != null) {
        $$("policyListing").clearAll();
    }
    
    if (jsonData != undefined) {
        
        if (jsonData != '') {
            try {
                arrFeaturesList = Array();
                changeJSON = Array();
                bDirtyFlag = false;

                var productTable = $("#product_table");
                productTable.empty();
                var configData = jsonData['feature_extended_conf_data'];
                var products = jsonData['products'];

                var headerRow = "";
                if (products.length > 0) {
                    headerRow += "<thead>";
                    headerRow += "<tr>";
                    headerRow += "<th class=\"text-left\">Feature</th>";
                }
                for (i = 0; i < products.length; i++) {
                    headerRow += "<th class=\"text-center\">" + products[i]["description"] + "</th>";
                }
                if (products.length > 0) {
                    headerRow += "</tr>";
                    headerRow += "</thead>";
                }
                productTable.append(headerRow);

                for (i = 0; i < products.length; i++) {
                    var features = products[i].features;
                    for (j = 0; j < features.length; j++) {
                        var bFound = false;
                        for (k = 0; k < arrFeaturesList.length; k++) {
                            if (arrFeaturesList[k].code == features[j].code) {
                                bFound = true;
                                break;
                            }
                        }
                        if (bFound == false) {
                            arrFeaturesList.push({ "name": features[j].name, "code": features[j].code, "ids": "" });
                        }
                    }
                }

                productTable.append("<tbody>");
                for (i = 0; i < arrFeaturesList.length; i++) {
                    var row = "<tr>";
                    row += "<td class=\"text-left\">" + arrFeaturesList[i].name + "</td>";
                    for (j = 0; j < products.length; j++) {
                        var state = "False";
                        var allowedForCorporate = "True";
                        var bFound = false;
                        for (k = 0; k < products[j].features.length; k++) {
                            if (products[j].features[k].code == arrFeaturesList[i].code) {
                                state = products[j].features[k].bEnabledForTheGroup;
                                allowedForCorporate = products[j].features[k].bEnabledForCorporate;
                                bFound = true;
                                break;
                            }
                        }

                        if (bFound == true) {
                            var switchID = Base64.encode(strSelectedGroup + "_" + products[j].description + "_" + arrFeaturesList[i].code);
                            switchID = switchID.replace(/\+/g, '-').replace(/\//g, '_').replace(/\=+$/, '');
                            row += "<td class=\"text-center\">";
                            row += "<label class=\"switch switch-primary\"><input id=\"" + switchID + "\" class=\"switch-input  featureToggle\" type=\"checkbox\" ";
                            if (state == "True") {
                                row += "checked=\"checked\"";
                            }
                            if (allowedForCorporate == "False")
                            {
                                row += " disabled=false";
                            }
                            row += ">";
                            row += "<span class=\"switch-track\"></span><span class=\"switch-thumb\"></span></label>";
                            row += "</td>";

                            // Add the id to the feature list
                            var strIds = arrFeaturesList[i].ids;
                            if (strIds != "") {
                                strIds += ",";
                            }
                            strIds += switchID;
                            arrFeaturesList[i].ids = strIds;
                        }
                        else {
                            row += "<td class=\"text-center\">&nbsp;</td>";
                        }
                    }
                    row += "</tr>";

                    productTable.append(row);


                    fnProcessExtendedFeatureHandler(arrFeaturesList[i].code);
                }
                productTable.append("</tbody>");
            //Start: Sanket: 28MAR2019
            //Added Codition for password policy json data
            // Sanket: 13JUN2019: Add parameter for password expiry days
                var sPwdPolicy = jsonData['password_policy'];
                var sPwdExpiryDays = jsonData['password_expiry_days'];
                if ((sPwdPolicy != undefined && sPwdPolicy != "") && (sPwdExpiryDays != undefined && sPwdExpiryDays != "")) {
                    $("#EXT_PWD").show(250);
                    }
                else {
                    $("#EXT_PWD").hide(250);
                }
                if (configData != undefined || sPwdPolicy != undefined) {
                    if (configData != "" || sPwdPolicy != "") {
                        fnSetFeaturesJSON(Base64.decode(configData), Base64.decode(sPwdPolicy), sPwdExpiryDays);
                }
                }
                //End: Sanket: 28MAR2019

            } catch (e) {
                // Do nothing
            }

        }
    }
};

// Function to record changes in the switches of the product features
$(document).on('click', '.featureToggle', function (e) {
    bDirtyFlag = true;
    var id = this.getAttribute("id");
    var ch = this.checked;
    if (id != undefined && ch != undefined && changeJSON != undefined) {
        try {
            if (id.length % 4 != 0)
                id += ('===').slice(0, 4 - (id.length % 4));
            id = id.replace(/-/g, '+').replace(/_/g, '/');
            var idData = Base64.decode(id);
            var elements = idData.split("_");
            var strGroupName = elements[0];
            var strProduct = elements[1];
            var strFeatureCode = elements[2];

            var bFound = false;
            for (i = 0; i < changeJSON.length; i++) {
                if (changeJSON[i].id == id) {
                    changeJSON[i].value = ch;
                    bFound = true;
                    break;
                }
            }
            if (bFound == false) {
                changeJSON.push({ "id": id, "value": ch });
            }

            // Call feature code processing to turn on or off a feature
            fnProcessExtendedFeatureHandler(strFeatureCode);
        } catch (e) {
            // Do nothing

        }
    }
});

// This function enables or disables the extended configuration based on the selection
function fnProcessExtendedFeatureHandler(strFeatureCode) {
    try {
        var bShow = false;
        for (i = 0; i < arrFeaturesList.length; i++) {
            if (arrFeaturesList[i].code == strFeatureCode) {
                var arrIds = arrFeaturesList[i].ids.split(",");
                for (j = 0; j < arrIds.length; j++) {
                    var selectedID = '#' + arrIds[j];
                    var cont = $()
                    var satisfied = $(selectedID).prop('checked');
                    if (satisfied == true) {
                        bShow = true;
                        break; // found atleast on true parameter
                    }
                }
                break;
            }
        }
        if (bShow == true) {
            $("#EXT_" + strFeatureCode).show(250);
        }
        else {
            $("#EXT_" + strFeatureCode).hide(250);
        }
    } catch (e) {
        console.log(e.message);
    }
}

// This function returns the string of the extended parameters
function fnGetFeaturesJSON() {
    

    var strReturnValue = "{";
    try {
        if ($("#EXT_L1").is(':visible') == true) {
            strReturnValue += "\"L1\":{";
            strReturnValue += "\"L1F1\":\"" + $("#L1F1").prop('checked') + "\",";
            strReturnValue += "\"L1F2\":\"" + $("#L1F2").prop('checked') + "\",";
            strReturnValue += "\"L1F3\":\"" + $("#L1F3").prop('checked') + "\",";
            strReturnValue += "\"L1F4\":\"" + $("#L1F4").prop('checked') + "\",";
            strReturnValue += "\"L1F5\":\"" + $("#L1F5").prop('checked') + "\",";
            strReturnValue += "\"L1F6\":\"" + $("#L1F6").prop('checked') + "\",";
            strReturnValue += "\"L1F7\":\"" + Base64.encode($("#L1F7").val()) + "\"";
            strReturnValue += "}";
        }
        if ($("#EXT_L5").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L5\":{";
            strReturnValue += "\"L5F1\":\"" + Base64.encode($("#L5F1").val()) + "\"";
            strReturnValue += "}";
        }
        if ($("#EXT_L6").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L6\":{";
            strReturnValue += "\"L6F1\":\"" + Base64.encode($("#L6F1").val()) + "\"";
            strReturnValue += "}";
        }
        if ($("#EXT_L7").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L7\":{";
            strReturnValue += "\"L7F1\":\"" + $("#L7F1").prop('checked') + "\",";
            strReturnValue += "\"L7F2\":\"" + $("#L7F2").prop('checked') + "\",";
            strReturnValue += "\"L7F3\":\"" + $("#L7F3").prop('checked') + "\",";
            strReturnValue += "\"L7F4\":\"" + $("#L7F4").prop('checked') + "\",";
            strReturnValue += "\"L7F5\":\"" + $("#L7F5").prop('checked') + "\"";
            strReturnValue += "}";
        }
        
        var policy = "";
        if (ruleJSON != undefined) {
            policy = Base64.encode(JSON.stringify(ruleJSON));
        }

        if (strReturnValue != "{") {
            strReturnValue += ",";
        }
        strReturnValue += "\"G\":{";
        strReturnValue += "\"GF1\":\"" + $("#GF1").val() + "\",";
        strReturnValue += "\"GF2\":\"" + policy + "\",";
        strReturnValue += "\"GF3\":\"" + $("#GF3").prop('checked') + "\",";
        strReturnValue += "\"GF4\":\"" + $("#GF4").prop('checked') + "\",";
        strReturnValue += "\"GF5\":\"" + $("#GF5").prop('checked') + "\",";
        strReturnValue += "\"GF6\":\"" + $("#GF6").prop('checked') + "\"";
        strReturnValue += "}";

        if ($("#EXT_L14").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L14\":{";
            strReturnValue += "\"L14F1\":\"" + $("#L14F1").prop('checked') + "\"";
            strReturnValue += "}";
        }
        /*25_10_2018_RJS*/
        if ($("#EXT_L11").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L11\":{";
            strReturnValue += "\"L11F6\":\"" + $("#L11F6").prop('checked') + "\",";
            strReturnValue += "\"L11F7\":\"" + $("#L11F7").prop('checked') + "\"";
            strReturnValue += "}";
        }
        /*25_10_2018_RJS*/
        //Start: Sanket:25MAR2019
        //Add new Password Complexity policy values from UI
        if ($("#EXT_PWD").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"Pwd_Complexity\":{";
            strReturnValue += "\"password_policy_minimum_length\":\"" + $("#password_policy_minimum_length").val() + "\",";
            strReturnValue += "\"password_policy_upper_case_length\":\"" + $("#password_policy_upper_case_length").val() + "\",";
            strReturnValue += "\"password_policy_lower_case_length\":\"" + $("#password_policy_lower_case_length").val() + "\",";
            strReturnValue += "\"password_policy_non_alpha_numeric_length\":\"" + $("#password_policy_non_alpha_numeric_length").val() + "\",";
            strReturnValue += "\"password_policy_numeric_length\":\"" + $("#password_policy_numeric_length").val() + "\",";
            strReturnValue += "\"password_expiry_days\":\"" + $("#password_expiry_days").val() + "\"";
            strReturnValue += "}";
            //End: Sanket :25MAR2019
        }
    } catch (e) {
        console.log(e.message);
    }
    strReturnValue += "}";
    return strReturnValue;
};

// This function sets the values of the loaded JSON
// Sanket: MAR2019 :Add  parameter for passward policy data
// Sanket: 13JUN2019: Add parameter for password expiry days
function fnSetFeaturesJSON(strFeaturesJSON, strPasswordPolicy, strPwdExpiryDays) {
    try {
        classificationJSON = [];
        if (strFeaturesJSON != undefined && strFeaturesJSON != '') {
        var featuresJSON = JSON.parse(strFeaturesJSON);
        }
        if (featuresJSON != undefined && featuresJSON != '') {
            if (featuresJSON.L1 != undefined && featuresJSON.L1 !=='') {
                if (featuresJSON.L1.L1F1 != undefined && featuresJSON.L1.L1F1 != '') {
                    fnToggleCheckbox($("#L1F1"), (featuresJSON.L1.L1F1.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F2 != undefined && featuresJSON.L1.L1F2 != '') {
                    fnToggleCheckbox($("#L1F2"), (featuresJSON.L1.L1F2.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F3 != undefined && featuresJSON.L1.L1F3 != '') {
                    fnToggleCheckbox($("#L1F3"), (featuresJSON.L1.L1F3.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F4 != undefined && featuresJSON.L1.L1F4 != '') {
                    fnToggleCheckbox($("#L1F4"), (featuresJSON.L1.L1F4.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F5 != undefined && featuresJSON.L1.L1F5 !='') {
                    fnToggleCheckbox($("#L1F5"), (featuresJSON.L1.L1F5.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F6 != undefined && featuresJSON.L1.L1F6 != '') {
                    fnToggleCheckbox($("#L1F6"), (featuresJSON.L1.L1F6.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F7 != undefined && featuresJSON.L1.L1F7 != '') {
                    $("#L1F7").val(Base64.decode(featuresJSON.L1.L1F7));
                }
            }
            if (featuresJSON.L5 != undefined && featuresJSON.L5 != '') {
                if (featuresJSON.L5.L5F1 != undefined && featuresJSON.L5.L5F1 != '') {
                    $("#L5F1").val(Base64.decode(featuresJSON.L5.L5F1));
                }
            }
            if (featuresJSON.L6 != undefined && featuresJSON.L6 !='') {
                if (featuresJSON.L6.L6F1 != undefined && featuresJSON.L6.L6F1 !='') {
                    $("#L6F1").val(Base64.decode(featuresJSON.L6.L6F1));
                }
            }
            if (featuresJSON.L7 != undefined && featuresJSON.L7 !='') {
                if (featuresJSON.L7.L7F1 != undefined && featuresJSON.L7.L7F1 !='') {
                    fnToggleCheckbox($("#L7F1"), (featuresJSON.L7.L7F1.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F2 != undefined && featuresJSON.L7.L7F2 !='') {
                    fnToggleCheckbox($("#L7F2"), (featuresJSON.L7.L7F2.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F3 != undefined && featuresJSON.L7.L7F3 !='') {
                    fnToggleCheckbox($("#L7F3"), (featuresJSON.L7.L7F3.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F4 != undefined && featuresJSON.L7.L7F4 !='') {
                    fnToggleCheckbox($("#L7F4"), (featuresJSON.L7.L7F4.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F5 != undefined && featuresJSON.L7.L7F5 !='') {
                    fnToggleCheckbox($("#L7F5"), (featuresJSON.L7.L7F5.toLowerCase() === 'true'));
                }
            }

            /*25_10_2018_RJS*/
            if (featuresJSON.L11 != undefined && featuresJSON.L11 != '') {
                if (featuresJSON.L11.L11F6 != undefined && featuresJSON.L11.L11F6 != '') {
                    fnToggleCheckbox($("#L11F6"), (featuresJSON.L11.L11F6.toLowerCase() === 'true'));                   
                }
                if (featuresJSON.L11.L11F7 != undefined && featuresJSON.L11.L11F7 != '') {
                    fnToggleCheckbox($("#L11F7"), (featuresJSON.L11.L11F7.toLowerCase() === 'true'));
                }
            }
            else {
                fnToggleCheckbox($("#L11F6"), 'true');
                fnToggleCheckbox($("#L11F7"), 'true');

            }
            /*25_10_2018_RJS*/


            if (featuresJSON.G != undefined && featuresJSON.G !='') {
                if (featuresJSON.G.GF1 != undefined && featuresJSON.G.GF1 !='') {
                    $("#GF1").val(featuresJSON.G.GF1);
                }
                if (featuresJSON.G.GF3 != undefined && featuresJSON.G.GF3 !='') {
                    fnToggleCheckbox($("#GF3"), (featuresJSON.G.GF3.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF4 != undefined && featuresJSON.G.GF4 !='') {
                    fnToggleCheckbox($("#GF4"), (featuresJSON.G.GF4.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF5 != undefined && featuresJSON.G.GF5 != '') {
                    fnToggleCheckbox($("#GF5"), (featuresJSON.G.GF5.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF6 != undefined && featuresJSON.G.GF6 != '') {
                    fnToggleCheckbox($("#GF6"), (featuresJSON.G.GF6.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF2 != undefined && featuresJSON.G.GF2 !='') {
                    var strRuleJSON = Base64.decode(featuresJSON.G.GF2);
                    if (strRuleJSON != undefined && strRuleJSON !='') {
                        ruleJSON = $.parseJSON(strRuleJSON);
                    }
                    if ($$("policyListing") != undefined && $$("policyListing") !='') {
                        $$("policyListing").clearAll();
                        $$("policyListing").parse(ruleJSON);
                    }
                }
            }
        }
        //Start: Sanket : 28MAR2019
        //Set values of password policy
        if (strPasswordPolicy != undefined && strPasswordPolicy != '') {
            var Pwd_Complexity = JSON.parse(strPasswordPolicy);
        }
        // Sanket: 13JUN2019: Set values for password expiry days
        if (strPwdExpiryDays != undefined && strPwdExpiryDays != '') {
            var Pwd_Expiry_Days = JSON.parse(strPwdExpiryDays);
        }
        if (Pwd_Complexity != undefined && Pwd_Complexity != '') {
            if (Pwd_Complexity.Pwd_Complexity.password_policy_minimum_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_minimum_length != '') {
                $("#password_policy_minimum_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_minimum_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_upper_case_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_upper_case_length != '') {
                $("#password_policy_upper_case_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_upper_case_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_lower_case_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_lower_case_length != '') {
                $("#password_policy_lower_case_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_lower_case_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_non_alpha_numeric_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_non_alpha_numeric_length != '') {
                $("#password_policy_non_alpha_numeric_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_non_alpha_numeric_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_numeric_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_numeric_length != '') {
                $("#password_policy_numeric_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_numeric_length);
            }
            if (Pwd_Expiry_Days != undefined && Pwd_Expiry_Days != '') {
                $("#password_expiry_days").val(Pwd_Expiry_Days);
                //End: Sanket : 28MAR2019
            }
        }
    } catch (e) {
        console.log(e.message);
    }
}

function fnToggleCheckbox($element,$value) {
    if ($element != undefined && $element.length > 0 && $element[0] != undefined && $element[0].checked != undefined) {
        $element[0].checked = $value;
    }
}