﻿
var m_folderSelected = "";
var m_fileSelected = "";


var bGroupAdd = false;
var bGroupDelete = false;
var bGroupMemberWriteAccess = false;
var bGroupMemberDeleteAccess = false;
var bGroupMemberAddAccess = false;
var bGroupMemberWebOnlyAccess = false;
var bGroupOwner = false;
var bGroupMember = false;
var m_strFolderForWhichRightsFetched = "~";

var m_arrRights = Array();

function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
}

function OnCustomCommand(s, e) {
    if (e.commandName == "file_edit" || e.commandName == "file_view") {
        FileManager.PerformCallback({ strCommand: e.commandName, strParameters: JSON.stringify({ 'filepath': m_fileSelected }) });
    }
    else if (e.commandName == 'ChangeView-Thumbnails') {
        FileManager.PerformCallback({ strCommand: e.commandName, strParameters: JSON.stringify({ 'viewType': 'Thumbnails' }) });
    }
    else if (e.commandName == 'ChangeView-Details') {
        FileManager.PerformCallback({ strCommand: e.commandName, strParameters: JSON.stringify({ 'viewType': 'Details' }) });
    }
    else if (e.commandName == 'new_document') {
        $("#modelNewFileSelection").modal('toggle');
    }
    else if (e.commandName == 'group_create') {
        $("#group_dialog_mode").val("0");
        $("#group_id").val(m_folderSelected);
        $("#modalGroup").modal('toggle');
    }
    else {
        FileManager.PerformCallback({ strCommand: e.commandName, strParameters: {} });
    }
}

function OnToolbarUpdating(s, e) {
    if (e.activeAreaName == "Folders" && m_folderSelected != "") {
        var enabled = e.activeAreaName == "Folders" && e.activeAreaName != "None";
        fnUpdateMenuItemsOnFolderChange();
    }
};

function fnSetVisible(item, state) {
    if (item != undefined) {
        item.SetVisible(state);
    }
};

// Function called to update commands on folder change
function fnUpdateMenuItemsOnFolderChange() {

    fnSetVisible(FileManager.GetToolbarItemByCommandName("file_edit"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("file_edit"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("file_view"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("file_view"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("new_document"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("new_document"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("group_create"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("group_create"), false);

    fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Delete"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Delete"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Create"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Create"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Rename"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Rename"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Download"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Download"), false);

    if (m_folderSelected != "") {
        var arrFolderTree = m_folderSelected.split("\\");
        if (arrFolderTree.length == 2) {
            // Its a Entity folder
            fnSetVisible(FileManager.GetToolbarItemByCommandName("group_create"), bGroupAdd);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("group_create"), bGroupAdd);
            fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Delete"), bGroupDelete);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Delete"), bGroupDelete);

        }
        else if (arrFolderTree.length >= 3) {
            // Its a Group folder
            fnSetVisible(FileManager.GetToolbarItemByCommandName("new_document"), bGroupOwner || bGroupMemberAddAccess);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("new_document"), bGroupOwner || bGroupMemberAddAccess);
            fnSetVisible(FileManager.GetToolbarItemByCommandName("group_create"), false);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("group_create"), false);
            fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Delete"), bGroupOwner || bGroupMemberDeleteAccess);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Delete"), bGroupOwner || bGroupMemberDeleteAccess);
            fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Create"), bGroupOwner || bGroupMemberAddAccess);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Create"), bGroupOwner || bGroupMemberAddAccess);
            fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Rename"), bGroupOwner || bGroupMemberWriteAccess);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Rename"), bGroupOwner || bGroupMemberWriteAccess);
            fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Download"), bGroupOwner || !bGroupMemberWebOnlyAccess);
            fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Download"), bGroupOwner || !bGroupMemberWebOnlyAccess);

        }
    }
}


function fnGetItemDetailsForGroup(strFolderSelected) {
    $("#idPropertiesWindow").html("<div style=\"text-align:center\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Collaboration/GetItemDetails", { "relativePath": strFolderSelected, "type": "folder" })
    .done(function (data) {
        if (data != undefined && data.group != undefined && data.group != "") {
            fnShowGroupPanel(data.group, strFolderSelected);
        }
        else if (data != undefined && data.message != undefined && data.message != "") {
            $("#idPropertiesWindow").html("<label>" + data.message + "</label>");
        }
        else {
            $("#idPropertiesWindow").html("<label></label>");
        }
    })
    .fail(function () {
        $("#idPropertiesWindow").html("<label>Unable to get the properties.</label>");
    });
}

function fnGetItemDetailsForFile(filename) {
    $("#idPropertiesWindow").html("<div style=\"text-align:center\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Collaboration/GetItemDetails", { "relativePath": filename, "type": "file"})
    .done(function (data) {
        if (data != undefined && data.file != undefined && data.file != "") {
            fnShowFilePanel(data.file);
        }
        else if (data != undefined && data.message != undefined && data.message != "") {
            $("#idPropertiesWindow").html("<label>" + data.message + "</label>");
        }
        else {
            $("#idPropertiesWindow").html("<label></label>");
        }

    })
    .fail(function () {
        $("#idPropertiesWindow").html("<label>Unable to get the properties.</label>");
    });
}

// This function is called when the current folder is changed
function CurrentFolderChanged(s, e) {
    $("#idPropertiesWindow").html("");
    if (e.fullName != undefined) {
        m_folderSelected = e.fullName;
        fnUpdateAccessRights();
        m_fileSelected = "";
        var arrFolderTree = m_folderSelected.split("\\");
        if (arrFolderTree.length >= 2) {
            fnGetItemDetailsForGroup(m_folderSelected);
        }
        else {
            $("#idPropertiesWindow").html("<label></label>");
        }
        $.post("/Collaboration/updatecurrentfolder", { "folder": m_folderSelected });
    }
};

function fnUpdateAccessRights() {
    if (m_strFolderForWhichRightsFetched != m_folderSelected) {
        // Lets check if the folder rights are already cached
        var bFound = false;
        var strEntityGroupName = fnGetEntityGroupName(m_folderSelected);
        var strExistingRights = "";
        for (i = 0; i < m_arrRights.length; i++) {
            if (m_arrRights[i].entitygroup == strEntityGroupName) {
                bFound = true;
                strExistingRights = m_arrRights[i].data;
                break;
            }
        }
        if (bFound == false) {
            // Get the folder rights
            $.post("/Collaboration/GetAccessRights", { "relativePath": m_folderSelected })
            .done(function (data) {
                if (data != undefined && data != "{}") {
                    try {
                        var objAccess = jQuery.parseJSON(data);
                        if (objAccess != undefined) {
                            bGroupAdd = objAccess.bGroupAdd;
                            bGroupDelete = objAccess.bGroupDelete;
                            bGroupMemberWriteAccess = objAccess.bGroupMemberWriteAccess;
                            bGroupMemberDeleteAccess = objAccess.bGroupMemberDeleteAccess;
                            bGroupMemberAddAccess = objAccess.bGroupMemberAddAccess;
                            bGroupMemberWebOnlyAccess = objAccess.bGroupMemberWebOnlyAccess;
                            bGroupOwner = objAccess.bGroupOwner;
                            bGroupMember = objAccess.bGroupMember;
                            // Cache the rights
                            var objRights = { 'entitygroup': strEntityGroupName, 'data': data };
                            m_arrRights.push(objRights);
                        }
                    } catch (e) {
                        console.write(e.message);
                    }
                }
                else {
                    bGroupAdd = false;
                    bGroupDelete = false;
                    bGroupMemberWriteAccess = false;
                    bGroupMemberDeleteAccess = false;
                    bGroupMemberAddAccess = false;
                    bGroupMemberWebOnlyAccess = false;
                    bGroupOwner = false;
                    bGroupMember = false;
                }
                m_strFolderForWhichRightsFetched = m_folderSelected;
                fnUpdateMenuItemsOnFolderChange();
            })
            .fail(function () {
            });
        }
        else {
            var objAccess = jQuery.parseJSON(strExistingRights);
            if (objAccess != undefined) {
                bGroupAdd = objAccess.bGroupAdd;
                bGroupDelete = objAccess.bGroupDelete;
                bGroupMemberWriteAccess = objAccess.bGroupMemberWriteAccess;
                bGroupMemberDeleteAccess = objAccess.bGroupMemberDeleteAccess;
                bGroupMemberAddAccess = objAccess.bGroupMemberAddAccess;
                bGroupMemberWebOnlyAccess = objAccess.bGroupMemberWebOnlyAccess;
                bGroupOwner = objAccess.bGroupOwner;
                bGroupMember = objAccess.bGroupMember;
            }
            fnUpdateMenuItemsOnFolderChange();
        }
    }
};
//This function extracts the Entity and group name from the passed variable
function fnGetEntityGroupName(strFolder)
{
    var strEntityGroupName = "";
    try {
        var arrFolderTree = strFolder.split("\\");
        // Remove Root folder if present
        if (arrFolderTree.length > 0)
        {
            if (arrFolderTree[0] == 'Secure Collaboration') {
                arrFolderTree.splice(0, 1);
            }
        }
        // Get Entity folder
        if(arrFolderTree.length > 0)
        {
            strEntityGroupName = arrFolderTree[0];
        }
        // Get Group Name
        if (arrFolderTree.length > 1) {
            strEntityGroupName = strEntityGroupName + "_" + arrFolderTree[1];
        }

    } catch (e) {
        console.write(e.message);
    }
    return strEntityGroupName;
    
}

// This function is called when the current file selection changes
function CurrentFileChanged(s, e) {
    m_fileSelected = "";
    var arrSelectedItems = s.GetSelectedItems();

    fnSetVisible(FileManager.GetToolbarItemByCommandName("file_edit"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("file_edit"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("file_view"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("file_view"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Rename"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Rename"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Download"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Download"), false);
    fnSetVisible(FileManager.GetToolbarItemByCommandName("new_document"), false);
    fnSetVisible(FileManager.GetContextMenuItemByCommandName("new_document"), false);

    $("#idPropertiesWindow").html("<label></label>");

    if (arrSelectedItems != undefined && arrSelectedItems.length == 1) {
        var item = arrSelectedItems[0];
        if (item != undefined) {
            if (item.id != undefined) {
                if (item.isSelected == true) {
                    m_fileSelected = item.id;
                    m_folderSelected = "";
                    var filename = item.id;
                    if (item.isFolder == false) {
                        fnSetVisible(FileManager.GetToolbarItemByCommandName("new_document"), bGroupOwner ||  bGroupMemberAddAccess);
                        fnSetVisible(FileManager.GetContextMenuItemByCommandName("new_document"), bGroupOwner || bGroupMemberAddAccess);
                        fnSetVisible(FileManager.GetToolbarItemByCommandName("file_edit"), bGroupOwner || bGroupMemberWriteAccess);
                        fnSetVisible(FileManager.GetContextMenuItemByCommandName("file_edit"), bGroupOwner || bGroupMemberWriteAccess);
                        fnSetVisible(FileManager.GetToolbarItemByCommandName("file_view"), bGroupOwner || bGroupMember);
                        fnSetVisible(FileManager.GetContextMenuItemByCommandName("file_view"), bGroupOwner || bGroupMember);
                        fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Rename"), bGroupOwner || bGroupMemberWriteAccess);
                        fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Rename"), bGroupOwner || bGroupMemberWriteAccess);
                        fnSetVisible(FileManager.GetToolbarItemByCommandName("fmtsi-Download"), bGroupOwner || !bGroupMemberWebOnlyAccess);
                        fnSetVisible(FileManager.GetContextMenuItemByCommandName("fmtsi-Download"), bGroupOwner || !bGroupMemberWebOnlyAccess);
                        fnGetItemDetailsForFile(filename);
                    }
                    else
                    {
                        fnGetItemDetailsForGroup(filename);
                    }
                }
            }
        }
    }

}

// This function shows the group panel in the properties window
function fnShowGroupPanel(group, group_id) {
    $("#idPropertiesWindow").html("");
    if (group != undefined && group != "") {
        var strPropertySheet = "";
        var objGroup = jQuery.parseJSON(group);
        if (objGroup != undefined) {


            strPropertySheet += "   <div class='card' style='margin-bottom:0px'>";
            strPropertySheet += "       <div class='card-header no-border'  style='padding:0px; border-bottom:solid 1px #CF3535'>";
            strPropertySheet += "           <div class='media'>";
            strPropertySheet += "               <div style='float:left;'>";
            strPropertySheet += "                   <h4>" + objGroup.Name + "</h4>";
            strPropertySheet += "               </div>";
            strPropertySheet += "               <div style='float:right;'>";
            if (bGroupOwner == true) {
                strPropertySheet += "                   <span width='32' height='32' style='color:#CF3535;cursor:pointer;' title='Edit Group' id='" + group_id + "' class='edit-group icon icon-pencil icon-2x'></span>";
            }
            strPropertySheet += "               </div>";
            strPropertySheet += "           </div>";
            strPropertySheet += "       </div>";
            strPropertySheet += "   </div>";
            strPropertySheet += "   <span style=\"font-size:small\"><b>OWNER:</b><br/><a href=\"mailto:" + objGroup.Owner + "\">" + objGroup.Owner + "</a></span>";
            strPropertySheet += "   <div class='card-body' style='padding-left:0px;padding-right:0px;'>";

            // List all the members here
            strPropertySheet += "       <div class='card' style='margin-bottom:20px'>";
            strPropertySheet += "           <div class='card-header no-border'  style='padding:0px; border-bottom:solid 1px #CF3535'>";
            strPropertySheet += "           <div class='media'>";
            strPropertySheet += "               <div style='float:left'>";
            strPropertySheet += "                   <h4>Members</h4>";
            strPropertySheet += "               </div>";
            strPropertySheet += "               <div  style='float:right'>";
            strPropertySheet += "                   <span width=\"32\" height=\"32\" style=\"color:#CF3535;\" class=\"icon icon-user icon-2x\"></span></span>";
            strPropertySheet += "           </div>";
            strPropertySheet += "       </div>";
            strPropertySheet += "   </div><br/>";

            for (i = 0; i < objGroup.MemberRights.length; i++) {
                var strMemberEntry = "";
                var HasDelete = false;
                if (objGroup.MemberRights[i].HasDelete != undefined) {
                    HasDelete = objGroup.MemberRights[i].HasDelete;
                }
                var HasWrite = false;
                if (objGroup.MemberRights[i].HasWrite != undefined) {
                    HasWrite = objGroup.MemberRights[i].HasWrite;
                }
                var HasWebOnly = false;
                if (objGroup.MemberRights[i].HasWebOnly != undefined) {
                    HasWebOnly = objGroup.MemberRights[i].HasWebOnly;
                }
                var HasAdd = false;
                if (objGroup.MemberRights[i].HasAddFile != undefined) {
                    HasAdd = objGroup.MemberRights[i].HasAddFile;
                }
                strMemberEntry += "<div class='list-group-item' href='#'>";
                strMemberEntry += "     <div class='media'>";
                strMemberEntry += "         <span class=\"icon icon-user icon-lg icon-fw\" style=\"color:#35CF35;\"></span><span style=\"font-size:small\">" + objGroup.MemberRights[i].Identity + "</span>";
                strMemberEntry += "<br/> ";
                strMemberEntry += "     <span class=\"icon ";
                strMemberEntry += (HasWrite == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += "  icon-lg\" style=\"color:#CF3535;font-size:small\">&nbsp;</span><span style=\"font-size:small\">Write</span> ";
                strMemberEntry += "     <span class=\"icon ";
                strMemberEntry += (HasDelete == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg\" style=\"color:#CF3535;font-size:small\">&nbsp;</span><span style=\"font-size:small\">Delete</span> ";
                strMemberEntry += "     <span class=\"icon ";
                strMemberEntry += (HasAdd == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg\" style=\"color:#CF3535;font-size:small\">&nbsp;</span><span style=\"font-size:small\">Add</span> ";
                strMemberEntry += "     <span class=\"icon ";
                strMemberEntry += (HasWebOnly == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg\" style=\"color:#CF3535;font-size:small\">&nbsp;</span><span style=\"font-size:small\">Web Only</span> ";
                strMemberEntry += "     </div>";
                strMemberEntry += "</div>";

                strPropertySheet += strMemberEntry;
            }

            strPropertySheet += "</div>";



            $("#idPropertiesWindow").html(strPropertySheet);

        }
    }
};

// This function shows the file panel in the properties window
function fnShowFilePanel(file) {
    $("#idPropertiesWindow").html("");
    if (file != undefined && file != "") {
        var strPropertySheet = "";
        var objFile = jQuery.parseJSON(file);
        if (objFile != undefined) {

            strPropertySheet += "        <div class='card' style='margin-bottom:0px'>";
            strPropertySheet += "            <div class='card-header no-border'  style='padding:0px; border-bottom:solid 1px #CF3535'>";
            strPropertySheet += "              <div class='media'>";
            strPropertySheet += "                <div class='media-middle media-body'>";
            strPropertySheet += "                    <h4>" + objFile.Name + "</h4>";
            strPropertySheet += "                </div>";
            strPropertySheet += "                <div class='media-right'>";
            strPropertySheet += "                    <span class='pull-right'><span width='32' height='32' style='color:#CF3535;' class='icon " + fnGetExtensionIcon(objFile.Ext) + " icon-2x'></span></span>";
            strPropertySheet += "                </div>";
            strPropertySheet += "              </div>";
            strPropertySheet += "            </div>";
            strPropertySheet += "        </div>";


            strPropertySheet += "    <div class='card-body' style='padding-left:0px;padding-right:0px;'>";
            strPropertySheet += "       <div class='list-group'>";
            strPropertySheet += "           <div class='list-group-item' href='#'>";
            strPropertySheet += "             <div class='media'>";
            strPropertySheet += "               <div class='media-left'>";
            strPropertySheet += "                   <span class='bg-pinterest circle sq-36' title='Current Version'>" + objFile.CurrentVersion + "</span>";
            strPropertySheet += "               </div>";
            strPropertySheet += "               <div class='media-middle media-body'>";
            strPropertySheet += "                 <h5 class='media-heading'><b>Modified:</b>" + objFile.ModifiedOn + "</h5>";
            strPropertySheet += "                 <h5 class='media-heading'><b>Size:</b>" + objFile.Size + "</h5>";
            strPropertySheet += "               </div>";
            strPropertySheet += "             </div>";
            strPropertySheet += "           </div>";
            strPropertySheet += "       </div>"; strPropertySheet += "    </div>";
            strPropertySheet += "</div>";

            if (objFile.Transactions.length > 0) {

                strPropertySheet += "    <div class='card' style='margin-bottom:0px'>";
                strPropertySheet += "        <div class='card-header no-border'  style='padding:0px; border-bottom:solid 1px #CF3535'>";
                strPropertySheet += "          <div class='media'>";
                strPropertySheet += "            <div style='float:left'>";
                strPropertySheet += "                <h4 id='transaction_label'>Version History</h4>";
                strPropertySheet += "            </div>";
                strPropertySheet += "            <div  style='float:right'>";
                strPropertySheet += "                <span width=\"32\" height=\"32\" style=\"color:#808080;title:'Events';cursor:pointer;\" class=\"show-events icon icon-calendar icon-2x\"></span>&nbsp;<span width=\"32\" height=\"32\" style=\"color:#CF3535;title:'Version History';cursor:pointer;\" class=\"show-history icon icon-clock-o icon-2x\"></span></span>";
                strPropertySheet += "          </div>";
                strPropertySheet += "        </div>";
                strPropertySheet += "    </div>";

                strPropertySheet += "    <div class='card-body' style='padding-left:0px;padding-right:0px;'>";
                strPropertySheet += "       <div class='list-group' id='history-body' >";
                for (i = objFile.Transactions.length - 2/*we skip last version*/; i >= 0 ; i--) {
                    if (objFile.Transactions[i].Action == '1'/*ADD*/ || objFile.Transactions[i].Action == '2'/*UPDATE*/) {
                        strPropertySheet += "           <div class='list-group-item' href='#'>";
                        strPropertySheet += "             <div class='media'>";
                        strPropertySheet += "               <div class='media-left'>";
                        strPropertySheet += "                   <span class='bg-twitter circle sq-36' title='History Version'>" + objFile.Transactions[i].Version + "</span>";
                        strPropertySheet += "               </div>";
                        strPropertySheet += "               <div class='media-middle media-body'>";
                        strPropertySheet += "                 <h5 class='media-heading'><a target='_blank' class='icon icon-eye icon-2x' style='text-decoration: none !important;color:#CF3535;' href='/Collaboration/DownloadDocument/?id=" + b64EncodeUnicode(m_fileSelected) + "&h=1&hid=" + b64EncodeUnicode(objFile.Transactions[i].FileCopyPath) + "'  title='View file'></a>&nbsp;" + objFile.Transactions[i].FormatedTime + "</h5>";
                        strPropertySheet += "                 <small>" + objFile.Transactions[i].ActionBy + "</small><br/>";
                        strPropertySheet += "                 <small><i>" + objFile.Transactions[i].Comment + "</i></small>";
                        strPropertySheet += "               </div>";
                        strPropertySheet += "               <div class='media-right'>";
                        strPropertySheet += "               </div>";
                        strPropertySheet += "             </div>";
                        strPropertySheet += "           </div>";
                    }
                }
                strPropertySheet += "       </div>";

                strPropertySheet += "       <div class='list-group' id='events-body' style='display:none'>";
                for (i = objFile.Transactions.length - 1; i >= 0 ; i--) {
                    strPropertySheet += "           <div class='list-group-item' href='#'>";
                    strPropertySheet += "             <div class='media'>";
                    strPropertySheet += "               <div class='media-left'>";
                    strPropertySheet += "                   <span class='icon icon-calendar title='Event'></span>";
                    strPropertySheet += "               </div>";
                    strPropertySheet += "               <div class='media-middle media-body'>";
                    strPropertySheet += "                 <h5 class='media-heading'>" + objFile.Transactions[i].FormatedTime + "</h5>";
                    strPropertySheet += "                 <small>" + objFile.Transactions[i].ActionBy + "</small><br/>";
                    strPropertySheet += "                 <small><i>" + objFile.Transactions[i].Comment + "</i></small>";
                    strPropertySheet += "               </div>";
                    strPropertySheet += "               <div class='media-right'>";
                    strPropertySheet += "               </div>";
                    strPropertySheet += "             </div>";
                    strPropertySheet += "           </div>";
                }
                strPropertySheet += "       </div>";



            }
            else {
                strPropertySheet += "<label>No History</label>";
            }
            strPropertySheet += "    </div>";
            strPropertySheet += "</div>";
            $("#idPropertiesWindow").html(strPropertySheet);

        }
    }
};

// This function returns the icon class for the passed extension
function fnGetExtensionIcon(Ext) {
    var iconName = "icon-file";
    if (Ext != undefined) {
        var Ext = Ext.toLowerCase();
        switch (Ext) {
            case "xls":
            case "xlsx":
            case "xlt":
            case "xltx":
            case "xlsm":
            case "ods":
            case "numbers":
                strFileType = "icon-file-excel-o";
                break;
            case "doc":
            case "docx":
            case "dot":
            case "dotx":
            case "pages":
            case "rtf":
                strFileType = "icon-file-word-o";
                break;
            case "ppt":
            case "pptx":
            case "pot":
            case "potx":
            case "keynote":
                strFileType = "icon-file-powerpoint-o";
                break;
            case "zip":
            case "rar":
            case "bzip":
            case "tar":
                strFileType = "icon-file-zip-o";
                break;
            case "pdf":
                strFileType = "icon-file-pdf-o";
                break;
            case "ai":
            case "drw":
            case "eps":
            case "ps":
            case "svg":
            case "bmp":
            case "gif":
            case "png":
            case "jpg":
            case "jpeg":
            case "psd":
            case "tif":
                strFileType = "icon-file-picture-o";
                break;
            case "wma":
            case "wav":
            case "ra":
            case "mp3":
            case "mid":
            case "m4a":
            case "aif":
            case "iff":
            case "m3u":
                strFileType = "icon-file-audio-o";
                break;
            case "3g2":
            case "3gp":
            case "asf":
            case "asx":
            case "avi":
            case "flv":
            case "mov":
            case "mp4":
            case "mpg":
            case "rm":
            case "swf":
            case "vob":
            case "wmv":
                strFileType = "icon-file-video-o";
                break;
            case "c":
            case "cpp":
            case "cc":
            case "java":
            case "php":
            case "cs":
            case "h":
            case "hpp":
            case "obj":
                strFileType = "icon-file-code-o";
                break;
            case "txt":
                strFileType = "icon-file-text-o";
                break;
        }
    }

    return iconName;
};


// This function replaces the icons on the tree structure with our own
function fnReplaceIcons() {
    FileManager.GetTreeView().GetNode(0).SetImageUrl('/Content/SCImages/sc_icon.png');
    var nodesEntities = FileManager.GetTreeView().GetNode(0).nodes;
    for (i = 0; i < nodesEntities.length; i++) {
        nodesEntities[i].SetImageUrl('/Content/SCImages/entity_icon_16.png');
        var nodesGroups = nodesEntities[i].nodes;
        for (j = 0; j < nodesGroups.length; j++) {
            nodesGroups[j].SetImageUrl('/Content/SCImages/group_folder_icon_16.png');
        }
    }
}

// Function to check if string is valid email
function isEmail(email) {
    var regex = /^['a-zA-Z0-9._-]+@([a-zA-Z0-9.-]+\.)+[a-zA-Z0-9.-]{2,10}$/;
    return regex.test(email);
};

// Function to validate group name
function isValidFolderName(folderName) {
    var regex = /:|\?|\\|\*|\"|<|>|\||%/;
    return !regex.test(folderName);
}

// Function to hide and display the menus and toolbar menu items
function fnUpdateMenuItems()
{
    if (bGroupAdd == true) { } else { }
    if (bGroupDelete == true) { } else { }

    if (bGroupMemberWriteAccess == true) { } else { }
    if (bGroupMemberDeleteAccess == true) { } else { }
    if (bGroupMemberAddAccess == true) { } else { }
    if (bGroupMemberWebOnlyAccess == true) { } else { }

    if (bGroupOwner == true) { } else { }

    if (bGroupMember == true) { } else { }
}


$(document).ready(function () {
    // Array to hold the list of the members for the selected group
    var m_lstMembers = Array();
    // Call the function to replace the icons
    fnReplaceIcons();


    /* SUPPORTING FUNCTIONS FOR EVENT HANDLERS */

    function fnValidateOKButton() {
        if (m_lstMembers.length == 0 || $("#group_name").val() == "") {
            $("#btnGroupOK").attr("disabled", "disabled");
        }
        else {
            $("#btnGroupOK").removeAttr("disabled");
        }
    };
    function fnRefreshIdentitiesInList() {
        if (m_lstMembers.length == 0) {
            $("#btnGroupOK").attr("disabled", "disabled");
            $("#group_dialog_member_list").html("<a class='list-group-item' href='#'>No Members</a>");
            $("#memberLegend").hide();
        }
        else {
            $("#memberLegend").show();
            var strMemberEntry = "";
            var bCheckPending = false;
            for (i = 0; i < m_lstMembers.length; i++) {
                if (m_lstMembers[i].status == '1'/*Check identity*/ || m_lstMembers[i].status == '2'/*Checking identity*/) {
                    bCheckPending = true;
                }
                strMemberEntry += "<a class='list-group-item member_item' index=" + i.toString() + " href='#'>";
                strMemberEntry += "    <span class='pull-right'>";
                strMemberEntry += "        <span class='icon ";
                strMemberEntry += (m_lstMembers[i].write == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg' style='color:#CF3535'>&nbsp;</span>Write";
                strMemberEntry += "        <span class='icon ";
                strMemberEntry += (m_lstMembers[i].delete == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg' style='color:#CF3535'>&nbsp;</span>Delete";
                strMemberEntry += "        <span class='icon ";
                strMemberEntry += (m_lstMembers[i].add == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg' style='color:#CF3535'>&nbsp;</span>Add";
                strMemberEntry += "        <span class='icon ";
                strMemberEntry += (m_lstMembers[i].webonly == true) ? "icon-check-square-o" : "icon-square-o";
                strMemberEntry += " icon-lg' style='color:#CF3535'>&nbsp;</span>Web Only";
                strMemberEntry += "        &nbsp;&nbsp;";
                strMemberEntry += "                <span class='icon icon-minus-square icon-lg remove_member_item' index=" + i.toString() + " title='Remove Member' style='color:#CF3535'></span>";
                strMemberEntry += "    </span>";
                if (bCheckPending == true) {
                    strMemberEntry += "    <span><img src='/Content/img/ajax-loader.gif'/></span>";
                }
                else {
                    if (m_lstMembers[i].status == '3'/*Identity is valid*/) {
                        strMemberEntry += "    <span class='icon icon-user icon-lg icon-fw' style='color:#35CF35' title='Galaxkey Registered'></span>";
                    }
                    else if (m_lstMembers[i].status == '4'/*Identity not valid*/) {
                        strMemberEntry += "    <span class='icon icon-user icon-lg icon-fw' style='color:#CF3535' title='Identity will be invited'></span>";
                    }
                }
                strMemberEntry += "        " + m_lstMembers[i].identity;
                strMemberEntry += "</a>";
            }
            if (bCheckPending == true || m_lstMembers.length == 0 || $("#group_name").val() == "") {
                $("#btnGroupOK").attr("disabled", "disabled");
            }
            else {
                $("#btnGroupOK").removeAttr("disabled");
            }
            $("#group_dialog_member_list").html(strMemberEntry);
            if (bCheckPending == true) {
                for (i = 0; i < m_lstMembers.length; i++) {
                    if (m_lstMembers[i].status == '1') {
                        fnCheckStatus(i);
                    }
                }
            }
        }
    };

    // Function to perform an AJAX request to check the status of the identities that require checking
    function fnCheckStatus(nIndex) {
        $.post("/Collaboration/checkstatus", { "identity": m_lstMembers[nIndex].identity })
              .done(function (data) {
                  var obj = jQuery.parseJSON(data);
                  if (obj.result == "true") {
                      // means the user is already registered with Galaxkey
                      m_lstMembers[nIndex].status = '3';
                  }
                  else {
                      // means the user is not registered with Galaxkey
                      m_lstMembers[nIndex].status = '4';
                  }
                  fnRefreshIdentitiesInList();
              })
             .fail(function () {
                 $("#group_message_for_group").html("Error obtaining status of identity: " + m_lstMembers[i].identity);
             });
    };


    /* EVENT HANDLERS FOR THE DIALOGS */
    // Function to start the new member dialog
    $(document).on('click', '#btnAddNewMember', function () {
        $("#mode").val("0"); // Insert Mode
        $("#index_being_edited").val("0");
        $("#member_identity").val("");
        $("#write").prop('checked', false);
        $("#delete").prop('checked', false);
        $("#add").prop('checked', false);
        $("#webonly").prop('checked', true);
        $("#member_message").html("");
        $("#modalGroupMembers").modal('toggle');
    });
    // Function to process the OK button on member add dialog
    $(document).on('click', '#btnMemberOK', function () {
        if ($("#mode").val() == "0") //INSERT
        {
            var newMemberIdentity = $("#member_identity").val();
            newMemberIdentity = newMemberIdentity.trim();
            newMemberIdentity = newMemberIdentity.toLowerCase();
            if (isEmail(newMemberIdentity) == true) {
                // Lets check if the member already exists in the list of members
                var bFound = false;
                for (i = 0; i < m_lstMembers.length; i++) {
                    var memberObject = m_lstMembers[i];
                    if (memberObject.identity == newMemberIdentity) {
                        bFound = true;
                        break;
                    }
                }
                if (bFound == false) {
                    // Member not present so we can add new
                    var objMember = { 'identity': newMemberIdentity, "write": $("#write").is(":checked"), "delete": $("#delete").is(":checked"), "add": $("#add").is(":checked"), "webonly": $("#webonly").is(":checked"), 'status': '1' };
                    m_lstMembers.push(objMember);
                    fnRefreshIdentitiesInList();
                    $("#modalGroupMembers").modal('toggle');
                }
                else {
                    $("#member_message").html("Identity already present");
                }
            }
            else {
                $("#member_message").html("Please enter a valid email for the identity");
            }
        }
        if ($("#mode").val() == "1") //UPDATE
        {
            var newMemberIdentity = $("#member_identity").val();
            var nIndex = parseInt($("#index_being_edited").val())
            newMemberIdentity = newMemberIdentity.trim();
            newMemberIdentity = newMemberIdentity.toLowerCase();
            if (isEmail(newMemberIdentity) == true) {
                m_lstMembers[nIndex].identity = newMemberIdentity;
                m_lstMembers[nIndex].write = $("#write").is(":checked");
                m_lstMembers[nIndex].add = $("#add").is(":checked");
                m_lstMembers[nIndex].delete = $("#delete").is(":checked");
                m_lstMembers[nIndex].webonly = $("#webonly").is(":checked");
                m_lstMembers[nIndex].status = '1';
                fnRefreshIdentitiesInList();
                $("#modalGroupMembers").modal('toggle');
            }
            else {
                $("#member_message").html("Please enter a valid email for the identity");
            }
        }
    });
    // Function to remove the member item from the list
    $(document).on('click', '.remove_member_item', function (e) {
        e.preventDefault();
        e.stopPropagation();
        var nIndex = parseInt(this.getAttribute("index"));
        m_lstMembers.splice($.inArray(nIndex, m_lstMembers), 1);
        fnRefreshIdentitiesInList();
    });
    // Function to edit the member
    $(document).on('click', '.member_item', function (e) {
        var nIndex = this.getAttribute("index");
        if (m_lstMembers.length > 0) {
            // Call the dialog to edit the member entry
            $("#mode").val("1"); // Update Mode
            $("#index_being_edited").val(nIndex.toString());
            $("#member_identity").val(m_lstMembers[nIndex].identity);
            $("#write").prop('checked', m_lstMembers[nIndex].write);
            $("#delete").prop('checked', m_lstMembers[nIndex].delete);
            $("#add").prop('checked', m_lstMembers[nIndex].add);
            $("#webonly").prop('checked', m_lstMembers[nIndex].webonly);
            $("#member_message").html("");
            $("#modalGroupMembers").modal('toggle');
        }
    });

    // Function called to edit a group
    $(document).on('click', '.edit-group', function (e) {
        var groupID = this.getAttribute("Id");
        if (groupID != undefined && groupID != "") {
            // Lets start the group edit dialog in edit mode
            $("#group_dialog_mode").val("1");
            $("#group_id").val(groupID);
            $("#modalGroup").modal('toggle');

        }
    });

    // Function to add the group
    $(document).on('click', '#btnGroupOK', function (e) {
        var strGroupName = $("#group_name").val();
        strGroupName = strGroupName.trim();
        if (strGroupName != "" && strGroupName != undefined) {
            if (isValidFolderName(strGroupName) == true) {
                var strValues = JSON.stringify({ "folder": m_folderSelected, "group_name": strGroupName, "members": JSON.stringify(m_lstMembers) });

                // Show the progress indicator on the dialog and disable the okay button
                $("#progress_indicator").show();
                $("#btnGroupOK").attr("disabled", "disabled");

                $.post("/Collaboration/group_function", { "folder": $("#group_id").val(), "group_name": strGroupName, "members": JSON.stringify(m_lstMembers), "mode": $("#group_dialog_mode").val() })
               .done(function (data) {
                   $("#progress_indicator").hide();
                   $("#btnGroupOK").removeAttr("disabled");
                   var obj = jQuery.parseJSON(data);
                   if (obj.result == "true") {
                       // Group has been added, we will refresh the tree node
                       $("#group_dialog_mode").val("0");
                       $("#group_id").val(m_folderSelected);
                       $("#modalGroup").modal('toggle');
                       FileManager.PerformCallback({ strCommand: 'nothing', strParameters: '' });
                   }
                   else {
                       $("#group_message_for_group").html(obj.message);
                   }
                   fnGetItemDetailsForGroup(m_folderSelected);
               })
              .fail(function () {
                  $("#progress_indicator").hide();
                  $("#btnGroupOK").removeAttr("disabled");
                  $("#group_message_for_group").html("Unable to add the group at this time, please try again");
              });
            }
            else {
                $("#group_message_for_group").html("The group name contains illegal characters");
            }
        }
        else {
            $("#group_message_for_group").html("Please enter a valid group name");
        }
    });

    // Function to add a new document to the current folder
    $(document).on('click', '#new_document', function (e) {
        $("#modelNewFileSelection").modal('toggle');
        var type = this.getAttribute("data-type");
        FileManager.PerformCallback({ strCommand: 'new_document', strParameters: JSON.stringify({ 'type': type, 'folder': m_folderSelected }) });

    });


    // Function to call event when the modal dialog to add group is called
    $('#modalGroup').on('shown.bs.modal', function () {
        $('#group_name').focus();
        $("#group_name").val("");
        $("#group_message_for_group").val("");
        $("#group_dialog_member_list").html("<a class='list-group-item' href='#'>No Members</a>");
        $("#memberLegend").hide();
        $("#btnGroupOK").attr("disabled", "disabled");
        m_lstMembers = Array();
        // If the dialog is loaded in update mode, we have to get the details for the group id
        var nMode = parseInt($("#group_dialog_mode").val());
        if (nMode == 1) {
            // Edit mode
            // Lets load the group details
            $("#progress_indicator").show();
            $("#btnGroupOK").attr("disabled", "disabled");
            $("#btnAddNewMember").hide();

            $.post("/Collaboration/GetItemDetails", { "relativePath": $("#group_id").val(), "type": "folder" })
           .done(function (data) {
               $("#progress_indicator").hide();
               $("#btnGroupOK").removeAttr("disabled");
               $("#btnAddNewMember").show();
               if (data != undefined && data.group != undefined && data.group != "") {
                   // Group details are obtained, we will fill in the dialog
                   var objGroup = jQuery.parseJSON(data.group);
                   $("#group_name").val(objGroup.Name);
                   m_lstMembers = Array();
                   for (i = 0; i < objGroup.MemberRights.length; i++) {
                       var objMember = { 'identity': objGroup.MemberRights[i].Identity, "write": objGroup.MemberRights[i].HasWrite, "delete": objGroup.MemberRights[i].HasDelete, "add": objGroup.MemberRights[i].HasAddFile, "webonly": objGroup.MemberRights[i].HasWebOnly, 'status': '3' };
                       m_lstMembers.push(objMember);
                   }
                   fnRefreshIdentitiesInList();
               }
               else {
                   $("#group_message_for_group").html(obj.message);
               }
           })
          .fail(function () {
              $("#progress_indicator").hide();
              $("#btnAddNewMember").hide();
              $("#group_message_for_group").html("Unable to get group details at this time, please try again");
          });

        }

    });
    $("#group_name").change(function () {
        fnValidateOKButton();
    });
    // Function to call event when the modal dialog to add members is called
    $('#modalGroupMembers').on('shown.bs.modal', function () {
        $('#member_identity').focus();
    });
    // Event handler to handle the enter key in the dialog for group members.
    $('#modalGroupMembers').on('keypress', function (event) {
        var keycode = (event.keyCode ? event.keyCode : event.which);
        if (keycode == '13') {
            $('#btnMemberOK').click();
        }
    });

    // Function to switch from History to Events
    $(document).on('click', '.show-events', function (e) {
        $('#history-body').hide(250);
        $('#events-body').show(250);
        $('.show-events').css('color', '#CF3535');
        $('.show-history').css('color', '#808080');
        $("#transaction_label").html("Events");

    });
    // Function to switch from events to History
    $(document).on('click', '.show-history', function (e) {
        $('#history-body').show(250);
        $('#events-body').hide(250);
        $('.show-events').css('color', '#808080');
        $('.show-history').css('color', '#CF3535');
        $("#transaction_label").html("Version History");
    });
});


/* FILE MANAGER CLIENT EVENT HANDLERS*/

function EndCallBack(s, e) {
    fnReplaceIcons();
};

function FolderCreating(s, e) {
    var bCancel = false;
    if (e.isFolder == true) {
        var arrFolderTree = e.fullName.split("\\");
        if (arrFolderTree.length == 1 || arrFolderTree.length == 2) {
            bCancel = true;
        }
    }
    e.cancel = bCancel;
};

function FileUploading(s, e) {
    if (bGroupAdd == true) {
        var arrFileNames = e.fileNames;
        var arrExistingFiles = s.GetItems();

        var founded = [];

        for (var i = 0; i < arrExistingFiles.length; i++) {
            var ef = arrExistingFiles[i];
            for (var j = 0; j < arrFileNames.length; j++) {
                if (ef.name.toLowerCase() == arrFileNames[j].toLowerCase())
                    founded.push(ef.name);
            }
        }
        if (founded.length > 0) {
            if (confirm("Do you want to overwrite " + founded.length + " files?")) {
                document.getElementById('overwrite').value = true;
                return
            }
            e.cancel = true;
        }
        document.getElementById('overwrite').value = false;
    }
    else {
        e.cancel = true;
        swal("Secure Collaboration", "You do not have access rights to upload file to this Group");
    }
};

function ErrorAlertDisplaying(s, e) {

    swal("Secure Collaboration", e.errorText);
    e.showAlert = false;
};

function ItemRenaming(s, e) {
    var bCancel = false;
    if (e.isFolder == true) {
        var arrFolderTree = e.fullName.split("\\");
        if (arrFolderTree.length == 1) {
            bCancel = true;
        }
    }
    e.cancel = bCancel;
};

function ItemDeleting(s, e) {
    var bCancel = false;
    if (e.isFolder == true) {
        var arrFolderTree = e.fullName.split("\\");
        if (arrFolderTree.length == 1) {
            bCancel = true;
        }
    }
    e.cancel = bCancel;
};

function FileManagerInit(s, e) {
    m_folderSelected = s.currentPath;
    fnUpdateAccessRights();
    if (m_folderSelected != "") {
        fnGetItemDetailsForGroup(m_folderSelected);
    }
};

function FileDownloading(s, e) {
    e.cancel = true;
    var strSelectedFile = e.file.id;
    // lets check if the file requested is being edited. If it is then we will give a message to the user
    $.post("/Collaboration/IsFileEdited", { "relativePath": strSelectedFile })
         .done(function (data) {
             if (data != undefined) {
                 if (data == "False") {
                     var filePath = "/Collaboration/DownloadFile/" + b64EncodeUnicode(strSelectedFile);
                     $('<form></form>')
                      .attr('action', filePath)
                      .appendTo('body').submit().remove();
                 }
                 else {
                     var filePath = "/Collaboration/DownloadDocument/" + b64EncodeUnicode(strSelectedFile);
                     $('<form></form>')
                      .attr('action', filePath)
                      .attr('target', "_blank")
                      .appendTo('body').submit().remove();
                 }
             }
             else {
                 alert("Unable to get file status");
             }
         })
        .fail(function () {
            alert("Unable to get file status");
        });

};
